
-------------------------------------
-- Saved Alchemy Locals
-------------------------------------
local tabName = "Saved Recipes"

local SAVED_LIST_SORT =
{
	filterType = { tiebreaker = "meetsUsageRequirement", tieBreakerSortOrder = ZO_SORT_ORDER_DOWNN },
	meetsUsageRequirement = { tiebreaker = "name", tieBreakerSortOrder = ZO_SORT_ORDER_UP, isNumeric = true },
	name = {tiebreaker = "numTraits", tieBreakerSortOrder = ZO_SORT_ORDER_DOWN },
	numTraits = { isNumeric = true },
}

local traitIcons = {
	["Breach"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_lowerspellresist.dds",
	["Cowardice"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_lowerspellpower.dds",
	["Defile"] = "/esoui/art/icons/alchemy/crafting_poison_trait_decreasehealing.dds",
	["Detection"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_detection.dds",
	["Enervation"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_lowerweaponcrit.dds",
	["Entrapment"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_stun.dds",
	["Fracture"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_lowerarmor.dds",
	["Gradual Ravage Health"] = "/esoui/art/icons/alchemy/crafting_poison_trait_dot.dds",
	["Heroism"] =  "/esoui/art/icons/alchemy/crafting_alchemy_trait_heroism.dds",
	["Hindrance"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_reducespeed.dds",
	["Increase Armor"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_increasearmor.dds",
	["Increase Spell Power"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_increasespellpower.dds",
	["Increase Spell Resist"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_increasespellresist.dds",
	["Weapon Critical"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_weaponcrit.dds",
--	["Increase Weapon Crit"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_weaponcrit.dds",
	["Increase Weapon Power"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_increaseweaponpower.dds" ,
	["Invisible"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_invisible.dds",
	["Lingering Health"] = "/esoui/art/icons/alchemy/crafting_poison_trait_hot.dds",
	["Maim"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_lowerweaponpower.dds",
	["Protection"] = "/esoui/art/icons/alchemy/crafting_poison_trait_protection.dds",
	["Ravage Health"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_ravagehealth.dds",
	["Ravage Magicka"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_ravagemagicka.dds",
	["Ravage Stamina"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_ravagestamina.dds",
	["Restore Health"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_restorehealth.dds",
	["Restore Magicka"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_restoremagicka.dds",
	["Restore Stamina"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_restorestamina.dds",
	["Speed"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_speed.dds",
	["Spell Critical"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_spellcrit.dds",
	["Timidity"] =  "/esoui/art/icons/alchemy/crafting_alchemy_trait_timidity.dds",
	["Uncertainty"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_lowerspellcrit.dds",
	["Unstoppable"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_unstoppable.dds",
	["Vitality"] = "/esoui/art/icons/alchemy/crafting_poison_trait_increasehealing.dds",
	["Vulnerability"] = "/esoui/art/icons/alchemy/crafting_poison_trait_damage.dds",
-- Poisons
	["Minor Breach"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_lowerspellresist.dds",
	["Minor Cowardice"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_lowerspellpower.dds",
	["Defile"] = "/esoui/art/icons/alchemy/crafting_poison_trait_decreasehealing.dds",
	["Expose Victim"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_detection.dds",
	["Minor Enervation"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_lowerweaponcrit.dds",
	["Immobilize"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_stun.dds",
	["Minor Fracture"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_lowerarmor.dds",
	["Gradual Ravage Health"] = "/esoui/art/icons/alchemy/crafting_poison_trait_dot.dds",
	["Heal Absorption"] =  "/esoui/art/icons/alchemy/crafting_alchemy_trait_heroism.dds",
	["Hindrance"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_reducespeed.dds",
	["Minor Fracture and Resolve"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_increasearmor.dds",
	["Minor Cowardice and Sorcery"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_increasespellpower.dds",
	["Minor Breach and Ward"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_increasespellresist.dds",
	["Minor Enervation and Savagery"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_weaponcrit.dds",
	["Minor Maim and Brutality"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_increaseweaponpower.dds" ,
	["Mark Victim"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_invisible.dds",
	["Gradual Drain Health"] = "/esoui/art/icons/alchemy/crafting_poison_trait_hot.dds",
	["Minor Maim"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_lowerweaponpower.dds",
	["Minor Vulnerability and Protection"] = "/esoui/art/icons/alchemy/crafting_poison_trait_protection.dds",
	["Poison Damage"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_ravagehealth.dds",
	["Increase Magicka Cost"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_ravagemagicka.dds",
	["Increase Stamina Cost"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_ravagestamina.dds",
	["Drain Health"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_restorehealth.dds",
	["Drain Magicka"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_restoremagicka.dds",
	["Drain Stamina"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_restorestamina.dds",
	["Hindrance and Major Expedition"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_speed.dds",
	["Minor Uncertainty and Prophecy"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_spellcrit.dds",
	["Timidity"] =  "/esoui/art/icons/alchemy/crafting_alchemy_trait_timidity.dds",
	["Minor Uncertainty"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_lowerspellcrit.dds",
	["Immobilize and Unstoppable"] = "/esoui/art/icons/alchemy/crafting_alchemy_trait_unstoppable.dds",
	["Minor Defile and Vitality"] = "/esoui/art/icons/alchemy/crafting_poison_trait_increasehealing.dds",
	["Minor Vulnerability"] = "/esoui/art/icons/alchemy/crafting_poison_trait_damage.dds",
}

local function isListEmpty()
	if IJAWH.savedVariables.savedAlchemyRecipes then
		return #IJAWH.savedVariables.savedAlchemyRecipes == 0
	end
	return false
end

local function showHidePanels(mode)
	local function isHidden(mode)
		if IsInGamepadPreferredMode() then
			IJAEA_KeyboardSavedAlchemy.control:SetHidden(true)
			return mode ~= 3 or (mode == 3 and isListEmpty())
		else
		IJAEA_KeyboardSavedAlchemy.control:GetNamedChild("Saves"):SetHidden(mode ~= 3)
		IJAEA_KeyboardSavedAlchemy.control:SetHidden(mode ~= 3)
			return mode ~= 3 or (mode == 3 and isListEmpty())
		end
	end
	
	IJAWH.craftTLW:SetHidden(mode == ZO_ALCHEMY_MODE_RECIPES or (mode == 3 and isListEmpty()))
	IJAWH:EnableReagentPanel(not IJAWH.craftTLW:IsHidden())
	IJAEA_SolventSlot:SetHidden(mode ~= 3 or (mode == 3 and isListEmpty()))
	
	if mode == 3 and isListEmpty() then CRAFTING_RESULTS:SetCraftingTooltip(nil) end
	
	IsJustaEasyAlchemy.AlchemyTLW:SetHidden(mode ~= ZO_ALCHEMY_MODE_CREATION)
	
	ZO_GamepadAlchemyTopLevelSlotContainerSlotCenter:SetHidden(isHidden(mode))
	ALCHEMY.control:GetNamedChild("SlotContainer"):SetHidden(isHidden(mode))
end
local function doTraitsMatch(traits, selectedTraits)
	if #traits ~= #selectedTraits then return false end
	local matchingTraits = 0
	
	for k,trait in pairs(traits) do
		trait = "^" .. trait .. "$"
		for i=1, #selectedTraits do
			if string.match(selectedTraits[i], trait) then matchingTraits = matchingTraits + 1 end
		end
	end
	return matchingTraits == #traits
end

local function convertName(name)
	return string.gsub(name, "%p", "")
end
local function normalizeName(name, filterType)
	if filterType == 1 then
		return string.gsub(name, "^%a+%sof", "Potion of")
	else
		return string.gsub(name, "%s%a+$", "")
	end
end
local function doNamesMatch(selectedName, savedName)
	local selectedName = convertName(selectedName)
	local savedName = convertName(savedName)
	return string.match(savedName, selectedName)
end

local function isAdded(name, selectedTraits)
	local savedAlchemyRecipes = IJAWH.savedVariables.savedAlchemyRecipes
	for k,v in pairs(savedAlchemyRecipes) do
		if doNamesMatch(name, v.name) then
			if doTraitsMatch(v.traits, selectedTraits) then return true end
		end
	end
	return false
end

local function meetsUsageRequirement(data)
	local icon, _, meetsUsageRequirement = GetItemLinkInfo(data.itemLink)
	return meetsUsageRequirement
end

local function getFirstData(selectedData)
	for i=1, #selectedData do
		if selectedData[i].name ~= '' then
			return selectedData[i].name, selectedData[i].icon, selectedData[i].itemLink, meetsUsageRequirement(selectedData[i])
		end
	end
end

local function saveCurrentRecipes(selectedData)
	local name, icon, itemLink, meetsUsageRequirement = getFirstData(selectedData)
	if name == '' then
		ZO_Alert(UI_ALERT_CATEGORY_ERROR, SOUNDS.NEGATIVE_CLICK, SI_IJAWH_UNKNOWNSAVE_WARNING)
		return
	end
	
	local savedAlchemyRecipes = IJAWH.savedVariables.savedAlchemyRecipes
	local selectedTraits = IsJustaEasyAlchemy.AlchemyHList.pattern
	local data = {
		name = normalizeName(name, selectedData[1].filterType),
		itemLink = itemLink,
		icon = icon,
		solventType = selectedData[1].solventType,
		filterType = selectedData[1].filterType,
		traits = selectedData[1].traits,
		numTraits = #selectedData[1].traits,
		recipeData = selectedData
	}
	if isAdded(normalizeName(data.name, data.filterType), data.traits) then return end
	table.insert(savedAlchemyRecipes, data)
	
	ZO_Alert(UI_ALERT_CATEGORY_ALERT, SOUNDS.EDIT_CLICK, SI_IJAWH_SAVEDALCHEMY_SAVED)


	table.sort(savedAlchemyRecipes, function(left, right)
		return ZO_TableOrderingFunction(left, right, "filterType", SAVED_LIST_SORT, ZO_SORT_ORDER_DOWN)
	end)

	IJAEA_SavedAlchemy:UpdateKeybindButton()
end

local function deleteSavedData(selectedData)
	local savedAlchemyRecipes = IJAWH.savedVariables.savedAlchemyRecipes
	for index,v in pairs(savedAlchemyRecipes) do
		if string.match(selectedData.solventType, v.solventType) then
			if doNamesMatch(selectedData.name, v.name) then
				if doTraitsMatch(v.traits, selectedData.traits) then
					ZO_Dialogs_ShowPlatformDialog("IJAWH_DELETE", {recipeName = selectedData.name, index = index, itemLink = selectedData.itemLink})
					return
				end
			end
		end
	end
end

local function buildSolventList()
	local solvents = {}
	local itemFormat = "|H0:item:<<1>>:30:1:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0|h|h"
	
	local sloventIds = {
		[1] = {[1] = "883", [2] = "1187", [3] = "4570", [4] = "23265", [5] = "23266", [6] = "23267", [7] = "23268", [8] = "64500", [9] = "64501"},
		[2] = {[1] = "75357", [2] = "75358", [3] = "75359", [4] = "75360", [5] = "75361", [6] = "75362", [7] = "75363", [8] = "75364", [9] = "75365"}
	}
	
	for i=1, 2 do
		local data = {}
		for k,itemId in pairs(sloventIds[i]) do
			local solventLink = zo_strformat(itemFormat, itemId)
			local solventData = IJAWH:getItemDataFromLink(solventLink)
			local icon, _, meetsUsageRequirement = GetItemLinkInfo(solventLink)
			solventData.meetsUsageRequirement = meetsUsageRequirement
			if meetsUsageRequirement and solventData.stackCount > 0 then
				solventData.filterType = i
				solventData.itemLink = solventLink
				data[k] = solventData
			end
		end
		solvents[i] = data
	end
	
	IJAEA_SavedAlchemy.solvents = solvents
end

local function setupSolventList()
	local templateParent = IsInGamepadPreferredMode() and ZO_GamepadAlchemyTopLevelSlotContainerSlotCenterZO_AlchemySolventSlot_Gamepad1 or ZO_AlchemyTopLevelSlotContainerSolventSlot
	IJAEA_SolventSlot:SetParent(templateParent)
	
	buildSolventList()
	ApplyTemplateToControl(IJAEA_SolventSlot, ZO_GetPlatformTemplate("IJAEA_SolventSlot"))
end

local function getSolventIndex(filterType)
	local list = IJAEA_SavedAlchemy.solventList.list
	local lastName = IJAEA_SavedAlchemy.lastUsedSolvents[filterType].name
	for i=1, #list do
		if string.match(list[i].name, lastName) then return i end
	end
end

local function setSolventScrollList(filterType)
	local solventList = IJAEA_SavedAlchemy.solvents[filterType]
	IJAEA_SavedAlchemy.solventList:Clear()
	for k, solventData in pairs(solventList) do
		IJAEA_SavedAlchemy.solventList:AddEntry(solventData)
	end
	IJAEA_SavedAlchemy.solventList:Commit()

	if IJAEA_SavedAlchemy.lastUsedSolvents[filterType] then
		local index = getSolventIndex(filterType)
		IJAEA_SavedAlchemy.solventList:SetSelectedDataIndex(index)
	end
end
	
local function getSolventByLevel(selectedData)
	local solventId
	--	get solvent based on level
	local skillRank = IJAWH:GetSkillRank(CRAFTING_TYPE_ALCHEMY, 1)
	if selectedData.solventType == "Poison" then
		solventId = select(skillRank, {"75357", "75358"}, "75359", "75360", "75361", "75362", "75363", "75364", "75365")
	else
		solventId = select(skillRank, {"883", "1187"}, "4570", "23265", "23266", "23267", "23268", "64500", "64501")
	end
		
	if type(solventId) == "table" then	-- for alchemy level 1
		if IJAWH:Contains(qName,IJAWH_WRIT_TYPES[4]) then
			solventId = solventId[1]
		else
			local playerLevel = GetUnitLevel("player")
			solventId = playerLevel <10 and solventId[1] or solventId[2]
		end
	end
	
	local itemFormat = "|H0:item:<<1>>:30:1:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0|h|h"
	local solventLink = zo_strformat(itemFormat, solventId)
	
	local solventData = IJAWH:getItemDataFromLink(solventLink)
	local icon, _, meetsUsageRequirement = GetItemLinkInfo(solventLink)
	solventData.meetsUsageRequirement = meetsUsageRequirement
	solventData.itemLink = solventLink
	solventData.filterType = selectedData.filterType
	
	return solventData
end

local function setSolventAsIngredient(solventData)	
	if not IJAWH.writData[IJAWH_WD_INDEX].ingredients[1] then IJAWH.writData[IJAWH_WD_INDEX].ingredients[1] = {} end
	IJAWH.writData[IJAWH_WD_INDEX].ingredients[1] = {
		[1] = solventData.itemLink,
		func = function(params)
			local itemLink = params[1]
			local yPos = 25
			local itemData = IJAWH:getItemDataFromLink(itemLink)
			local label, stackLabel, hasEnough = IJAWH:GetIngredientLabel(itemData,1)
			local ingredList = label .. ": " .. stackLabel
			return ingredList, yPos
		end
	}
end

local function finalizeSolvent(solventData)
	setSolventAsIngredient(solventData)
	
	IJAWH_CurrentSolvent = solventData
	
	IJAWH:RefreshKeybinds()
	IsJustaEasyAlchemy:UpdatePanel()
end

local lastSelectedRecipe = {}
local function isSameRecipe(name, selectedTraits)
	local recipeList = lastSelectedRecipe
	if recipeList.name then
		if doNamesMatch(name, recipeList.name) then
			if doTraitsMatch(recipeList.traits, selectedTraits) then return true end
		end
	end
	return false
end

local function addToRecipeList(selectedData)
--	if not meetsUsageRequirement(selectedData) then return end
	if isSameRecipe(selectedData.name, selectedData.traits) then return end
	IJAWH:EnableReagentPanel(true)
	IJAWH.recipeList:Clear()
	for i=1, #selectedData.recipeData do
		local recipeData = {}
		if ZO_Alchemy_IsThirdAlchemySlotUnlocked() then
			IJAWH.recipeList:AddEntry(selectedData.recipeData[i])
		else
			if #selectedData.recipeData[i].reagentSlots == 2 then
				IJAWH.recipeList:AddEntry(selectedData.recipeData[i])
			end
		end
	end
	IJAWH.recipeList:Commit()
	
	local filterType = selectedData.filterType
	local solventData = {}
	
	
	if lastSelectedRecipe.filterType ~= filterType then
		setSolventScrollList(filterType)
	end
	
	if not IJAEA_SavedAlchemy.lastUsedSolvents[filterType] then
		solventData = getSolventByLevel(selectedData)
		IJAEA_SavedAlchemy.lastUsedSolvents[filterType] = solventData
	else
		solventData = IJAEA_SavedAlchemy.lastUsedSolvents[filterType]
	end
	
	local index = getSolventIndex(filterType)
	IJAEA_SavedAlchemy.solventList:SetSelectedDataIndex(index)

	finalizeSolvent(solventData)
	
	lastSelectedRecipe = {
		name = selectedData.name,
		traits = selectedData.traits,
		filterType = filterType
	}
end

local function initSolventScrollList()
    local function EqualityFunction(leftData, rightData)
        return leftData.recipe == rightData.recipe
    end

    local function SetupFunction(control, data, selected, selectedDuringRebuild, enabled)
    end
	
    local function OnSelectedPatternChanged(selectedData, oldData, selectedDuringRebuild)
		if not oldData then return end
		
		local filterType = selectedData.filterType
		IJAEA_SavedAlchemy.lastUsedSolvents[filterType] = selectedData
		finalizeSolvent(selectedData)
    end
	
    local solventList = ZO_HorizontalScrollList:New(IJAEA_SolventSlot, "IJAEA_SolventSlot_SlotTemplate", 3, SetupFunction, EqualityFunction)
    solventList:SetOnSelectedDataChangedCallback(function(selectedData, oldData, selectedDuringRebuild)
        OnSelectedPatternChanged(selectedData, oldData, selectedDuringRebuild)
    end)
	
	IJAEA_SavedAlchemy.solventList = solventList
	
end

local function isSaveButtonEnabled()
	if IJAWH.recipeList.list then
		local recipeData = IJAWH.recipeList.list
		if recipeData == nil or #recipeData < 1 then return false end
		recipeData = recipeData[1]
		local traits = recipeData.traits
		local name = recipeData.name
		if isAdded(normalizeName(recipeData.name, recipeData.filterType), traits) then
			return false
		else
			return not IJAWH.activeEvents.UpdateTicRegistered and not ZO_CraftingUtils_IsPerformingCraftProcess()
		end
	end
end

local function isLocked(data)
	return isSameRecipe(data.name, data.traits) or not data.meetsUsageRequirement
end

-------------------------------------
-- Saved Alchemy Main
-------------------------------------
IJAEA_SavedAlchemy = {}
IJAEA_GamepadSavedAlchemy = {}
IJAEA_KeyboardSavedAlchemy = {}
		
function IJAEA_SavedAlchemy:Init()
	if not IJAWH.savedVariables.savedAlchemyRecipes then IJAWH.savedVariables.savedAlchemyRecipes = {} end
	self:intTabKB()
	self:InitTabGP()
	
	IJAEA_GamepadSavedAlchemy:InitSaveList()
	IJAEA_GamepadSavedAlchemy:InitScene()
	IJAEA_GamepadSavedAlchemy:InitKeybindStripDescriptors()
	
	IJAEA_KeyboardSavedAlchemy:InitSaveList()
	IJAEA_KeyboardSavedAlchemy:InitKeybindStripDescriptors()
	
	initSolventScrollList()
	IJAEA_SavedAlchemy.lastUsedSolvents = {}
end

function IJAEA_SavedAlchemy:intTabKB()
	local creationData = {
		activeTabText = tabName,
		categoryName = tabName,
		descriptor = 3,
		normal = "esoui/art/inventory/inventory_tabicon_consumables_up.dds",
		pressed = "esoui/art/inventory/inventory_tabicon_consumables_down.dds",
		highlight = "esoui/art/inventory/inventory_tabicon_consumables_over.dds",
		disabled = "esoui/art/inventory/inventory_tabicon_consumables_disabled.dds",
--		visible = function() return isTabVisable() end,
		enabled = function() return IsJustaEasyAlchemy.isEasyAlchemy end,
		callback = function(creationData)
			ALCHEMY.modeBarLabel:SetText(tabName)
			ALCHEMY:SetMode(creationData.descriptor)
		end
	}
	ZO_MenuBar_AddButton(ALCHEMY.modeBar, creationData)
	ZO_PreHook(ALCHEMY, "SetMode", function(self, mode)
		if IsJustaEasyAlchemy.isEasyAlchemy then
			if self.mode ~= mode then
				showHidePanels(mode)
				
				if mode == ZO_ALCHEMY_MODE_CREATION then
					IJAEA_SavedAlchemy:AddKeybindButton()
					IsJustaEasyAlchemy:OnAlchemyStation()
				else
					IJAEA_SavedAlchemy:RemoveKeybindButton()
				end
				
				if mode == 3 then 
					EVENT_MANAGER:UnregisterForUpdate("IJAWH_UpdateTic")
					EVENT_MANAGER:UnregisterForUpdate("IJAWH_RepeatProgress")
					IJAWH.activeEvents.UpdateTicRegistered = false
					IsJustaEasyAlchemy.LoadignProgressAnimation:PlayBackward()
					
					local oldMode = self.mode
					CRAFTING_RESULTS:SetCraftingTooltip(nil)
					if oldMode == ZO_ALCHEMY_MODE_RECIPES then
						PROVISIONER:RemoveFromCraftingScene()
						KEYBIND_STRIP:AddKeybindButtonGroup(self.keybindStripDescriptor)
					end
					lastSelectedRecipe = {}
					self.mode = mode
					setupSolventList()
					IJAEA_KeyboardSavedAlchemy.saves:HandleDirtyEvent()
					self.control:GetNamedChild("Inventory"):SetHidden(true)
--					self.control:GetNamedChild("SlotContainer"):SetHidden(false)
					
					CRAFTING_RESULTS:SetCraftingTooltip(self.tooltip)
					CRAFTING_RESULTS:SetTooltipAnimationSounds(SOUNDS.ALCHEMY_CREATE_TOOLTIP_GLOW_SUCCESS, SOUNDS.ALCHEMY_CREATE_TOOLTIP_GLOW_FAIL)
					self:ResetMultiCraftNumIterations()
					self:UpdateTooltip()
					
					local descriptor = IJAEA_KeyboardSavedAlchemy.saves.filterType
					IJAEA_KeyboardSavedAlchemy:SetActiveFilterByDescriptor(descriptor)
					return true
				end
			end
		end
	end)
end

function IJAEA_SavedAlchemy:InitTabGP()
	local data = ZO_GamepadEntryData:New(tabName, "esoui/art/inventory/inventory_tabicon_consumables_up.dds")
	
	data.mode = 3
	data.enabled = function() return IsJustaEasyAlchemy.isEasyAlchemy end
--	data.visible = function() return isTabVisable() end,
	GAMEPAD_ALCHEMY.modeList:AddEntry("ZO_GamepadItemEntryTemplate", data)
	GAMEPAD_ALCHEMY.modeList:Commit()
	
	ZO_PreHook(GAMEPAD_ALCHEMY, "SelectMode", function(self)
		IJAEA_KeyboardSavedAlchemy.control:GetNamedChild("Saves"):SetHidden(true)
		IJAEA_KeyboardSavedAlchemy.control:SetHidden(true)
				
		if not IsJustaEasyAlchemy.isEasyAlchemy then return false end
		local data = self.modeList:GetTargetData()
		
		showHidePanels(data.mode)
		IsJustaEasyAlchemy.AlchemyTLW:SetHidden(data.mode ~= ZO_ALCHEMY_MODE_CREATION)
		
		if data.mode == ZO_ALCHEMY_MODE_CREATION then
			IJAEA_SavedAlchemy:AddKeybindButton()
			IsJustaEasyAlchemy:OnAlchemyStation()
		else
			IJAEA_SavedAlchemy:RemoveKeybindButton()
		end
		
		
		IJAWH:RemoveKeybinds()
		if data then
			setupSolventList()
			if data.mode == 3 then
				SCENE_MANAGER:Push("gamepad_alchemy_saves")
			end
		end
	end)

	ZO_PreHook(GAMEPAD_ALCHEMY, "IsSystemShowing", function(self)
		return SCENE_MANAGER:IsShowing("gamepad_alchemy_saves")
	end)
end

function IJAEA_SavedAlchemy:UpdateKeybindButton()
	if IsInGamepadPreferredMode() then 
		KEYBIND_STRIP:UpdateKeybindButton(IJAEA_GamepadSavedAlchemy.saveKeybindButton)
		KEYBIND_STRIP:UpdateKeybindButtonGroup(GAMEPAD_ALCHEMY.mainKeybindStripDescriptor)
	else
		KEYBIND_STRIP:UpdateKeybindButton(IJAEA_KeyboardSavedAlchemy.saveKeybindButton)
		KEYBIND_STRIP:UpdateKeybindButtonGroup(ALCHEMY.keybindStripDescriptor)
	end
end

function IJAEA_SavedAlchemy:AddKeybindButton()
	if IsInGamepadPreferredMode() then
		if not KEYBIND_STRIP:HasKeybindButton(IJAEA_GamepadSavedAlchemy.saveKeybindButton) then
			KEYBIND_STRIP:AddKeybindButton(IJAEA_GamepadSavedAlchemy.saveKeybindButton)
		end
	elseif not KEYBIND_STRIP:HasKeybindButton(IJAEA_KeyboardSavedAlchemy.saveKeybindButton) then
		KEYBIND_STRIP:AddKeybindButton(IJAEA_KeyboardSavedAlchemy.saveKeybindButton)
	end
	self:UpdateKeybindButton()
end

function IJAEA_SavedAlchemy:RemoveKeybindButton()
	if IsInGamepadPreferredMode() then 
		KEYBIND_STRIP:RemoveKeybindButton(IJAEA_GamepadSavedAlchemy.saveKeybindButton)
		KEYBIND_STRIP:UpdateKeybindButtonGroup(GAMEPAD_ALCHEMY.mainKeybindStripDescriptor)
	else
		KEYBIND_STRIP:RemoveKeybindButton(IJAEA_KeyboardSavedAlchemy.saveKeybindButton)
		KEYBIND_STRIP:UpdateKeybindButtonGroup(ALCHEMY.keybindStripDescriptor)
	end
end

-------------------------------------
-- Gamepad scene and list
-------------------------------------
function IJAEA_GamepadSavedAlchemy:InitScene()
	local skillLineXPBarFragment = ZO_FadeSceneFragment:New(ZO_GamepadAlchemyTopLevelSkillInfo)
	GAMEPAD_ALCHEMY_SAVEDLIST_FRAGMENT = ZO_CreateQuadrantConveyorFragment(self.control:GetNamedChild("ContainerInventory"))

	GAMEPAD_ALCHEMY_SAVED_SCENE = GAMEPAD_ALCHEMY:CreateInteractScene("gamepad_alchemy_saves")

	GAMEPAD_ALCHEMY_SAVED_SCENE:SetInputPreferredMode(INPUT_PREFERRED_MODE_ALWAYS_GAMEPAD)
	GAMEPAD_ALCHEMY_SAVED_SCENE:AddFragment(skillLineXPBarFragment)
	GAMEPAD_ALCHEMY_SAVED_SCENE:AddFragmentGroup(FRAGMENT_GROUP.GAMEPAD_DRIVEN_UI_WINDOW)
	GAMEPAD_ALCHEMY_SAVED_SCENE:AddFragment(GAMEPAD_CRAFTING_RESULTS_FRAGMENT)
	GAMEPAD_ALCHEMY_SAVED_SCENE:AddFragment(GAMEPAD_ALCHEMY_FRAGMENT)
	GAMEPAD_ALCHEMY_SAVED_SCENE:AddFragment(GAMEPAD_ALCHEMY_SAVEDLIST_FRAGMENT)
	GAMEPAD_ALCHEMY_SAVED_SCENE:AddFragment(GAMEPAD_ALCHEMY_SLOTS_FRAGMENT)
	GAMEPAD_ALCHEMY_SAVED_SCENE:AddFragment(GAMEPAD_NAV_QUADRANT_1_BACKGROUND_FRAGMENT)
	GAMEPAD_ALCHEMY_SAVED_SCENE:AddFragment(MINIMIZE_CHAT_FRAGMENT)
	GAMEPAD_ALCHEMY_SAVED_SCENE:AddFragment(GAMEPAD_MENU_SOUND_FRAGMENT)
	GAMEPAD_ALCHEMY_SAVED_SCENE:AddFragment(CRAFTING_WINDOW_KEYBIND_INTERCEPT_LAYER_FRAGMENT)
	
	GAMEPAD_ALCHEMY_SAVED_SCENE:RegisterCallback("StateChange", function(oldState, newState)
		if newState == SCENE_SHOWING then
			KEYBIND_STRIP:RemoveDefaultExit()
			KEYBIND_STRIP:AddKeybindButtonGroup(self.mainKeybindStripDescriptor)
			self.saves.list:Activate()
			self.saves:OnShow()
			lastSelectedRecipe = {}
			
			GAMEPAD_CRAFTING_RESULTS:SetCraftingTooltip(GAMEPAD_ALCHEMY.tooltip)
			GAMEPAD_CRAFTING_RESULTS:SetTooltipAnimationSounds(SOUNDS.ALCHEMY_CREATE_TOOLTIP_GLOW_SUCCESS, SOUNDS.ALCHEMY_CREATE_TOOLTIP_GLOW_FAIL)
			GAMEPAD_ALCHEMY:UpdateTooltip()
			
			IJAEA_GamepadSavedAlchemyTopLevel:SetHidden(false)
			
			
			IJAWH.craftPanel.header:SetText(GetString(SI_IJAWH_EASYALCHEMY))
			IJAWH.craftPanel.icon:SetTexture(IJAWH.iconList[GetCraftingInteractionType()])
			
--			IJAWH.craftTLW:SetHidden(false)
--			IJAWH:EnableReagentPanel(true)
			IJAWH:AddKeybinds()
		elseif newState == SCENE_HIDDEN then
			self.saves.list:Deactivate()
			
			IJAEA_GamepadSavedAlchemyTopLevel:SetHidden(true)
			KEYBIND_STRIP:RemoveKeybindButtonGroup(self.mainKeybindStripDescriptor)
			KEYBIND_STRIP:RestoreDefaultExit()
			
			self.saves:HandleDirtyEvent()
			GAMEPAD_CRAFTING_RESULTS:SetCraftingTooltip(nil)
			GAMEPAD_ALCHEMY.tooltip:SetHidden(true)
		end
	end)
end

function IJAEA_GamepadSavedAlchemy:InitKeybindStripDescriptors()
		self.mainKeybindStripDescriptor =
	{
		alignment = KEYBIND_STRIP_ALIGN_LEFT,
		-- Add / remove
		{
			name = "Select",
			keybind = "UI_SHORTCUT_PRIMARY",
			visible = function()
				return self.saves.list:GetTargetData() ~= nil
			end,
			enabled = function()
				return self.saves.list:GetTargetData() ~= nil
			end,
			callback = function()
				local targetData = self.saves.list:GetTargetData()
				addToRecipeList(targetData)
				self.saves:Refresh()
			end,
		},
		-- Perform craft
		{
			name = function()
				local cost = GetCostToCraftAlchemyItem(GAMEPAD_ALCHEMY.solventSlot:GetBagAndSlot())
				return ZO_CraftingUtils_GetCostToCraftString(cost)
			end,
			keybind = "UI_SHORTCUT_SECONDARY",
			gamepadOrder = 1000,
			callback = function()
				GAMEPAD_ALCHEMY:Create(1)
			end,
			enabled = function()
				return GAMEPAD_ALCHEMY:ShouldCraftButtonBeEnabled()
			end,
			sound = SOUNDS.GAMEPAD_ALCHEMY_BEGIN,
		},
		-- Multicraft
		{
			name = GetString(SI_GAMEPAD_CRAFT_MULTIPLE),
			keybind = "UI_SHORTCUT_QUATERNARY",
			gamepadOrder = 1010,
			callback = function()
				local itemLink, _ = GetAlchemyResultingItemLink(GAMEPAD_ALCHEMY:GetAllCraftingBagAndSlots())
				ZO_GamepadCraftingUtils_ShowMultiCraftDialog(GAMEPAD_ALCHEMY, itemLink)
			end,
			enabled = function()
				return GAMEPAD_ALCHEMY:ShouldMultiCraftButtonBeEnabled()
			end,
		},
		-- Clear selections
		{
			name = "Delete Recipe",
			keybind = "UI_SHORTCUT_TERTIARY",
			gamepadOrder = 1020,
			callback = function()
				local targetData = self.saves.list:GetTargetData()
				deleteSavedData(targetData)
			end,
			
			visible = function()
				return self.saves.list:GetTargetData() ~= nil
			end,
		},
	}
	ZO_GamepadCraftingUtils_AddGenericCraftingBackKeybindsToDescriptor(self.mainKeybindStripDescriptor)
	ZO_CraftingUtils_ConnectKeybindButtonGroupToCraftingProcess(self.mainKeybindStripDescriptor)
	ZO_Gamepad_AddListTriggerKeybindDescriptors(self.mainKeybindStripDescriptor, self.saves:GetList())
	
	self.saveKeybindButton = 
	{
		alignment = KEYBIND_STRIP_ALIGN_LEFT,
		name = "Save",
		keybind = "UI_SHORTCUT_LEFT_STICK",
		gamepadOrder = 2050,
		visible = function()
			return true
		end,
		enabled = function()
			return isSaveButtonEnabled()
		end,
		callback = function()
			saveCurrentRecipes(IJAWH.recipeList.list)
		end,
	}
end

function IJAEA_GamepadSavedAlchemy:InitSaveList()
	self.control = IJAEA_GamepadSavedAlchemyTopLevel
	local inventory = self.control:GetNamedChild("ContainerInventory")
	
	self.saves = IJAEA_GamepadSavedAlchemyList:New(self, inventory)

	self.saves.list:SetOnTargetDataChangedCallback(function(list, selectedData)
		KEYBIND_STRIP:UpdateKeybindButtonGroup(self.mainKeybindStripDescriptor)
		-- set list to writPanel
	end)
	self.saves:GetList().CalculateParametricOffset = function(self, startAdditionalPadding, endAdditionalPadding, distanceFromCenter, continuousParametricOffset)
		local additionalPaddingEasingFunc
		if startAdditionalPadding < endAdditionalPadding then
			additionalPaddingEasingFunc = ZO_LinearEase
		end
		return ZO_ParametricScrollList.CalculateParametricOffset(self, startAdditionalPadding, endAdditionalPadding, distanceFromCenter, continuousParametricOffset, additionalPaddingEasingFunc)
	end
	self.saves:SetCustomExtraData(
		function(...)
--			d( "SetCustomExtraData", ...)
		end
	)
end
	
IJAEA_GamepadSavedAlchemyList = ZO_GamepadCraftingInventory:Subclass()

function IJAEA_GamepadSavedAlchemyList:New(owner, control, ...)
	return ZO_GamepadCraftingInventory.New(self, owner, control, ...)
end

function IJAEA_GamepadSavedAlchemyList:Initialize(owner, control, ...)
	ZO_GamepadCraftingInventory.Initialize(self, control, ...)
	self.owner = owner
	self.filterType = NO_FILTER
	self:SetNoItemLabelText("No saved recipes.")
end

function IJAEA_GamepadSavedAlchemyList:GetList()
	return self.list
end

function IJAEA_GamepadSavedAlchemyList:AddListDataTypes()
 	local function SetupTrait(controls, recipeData)
		local numTraits = #recipeData.traits
		for i, traitControl in ipairs(controls) do
			if i > numTraits then
				traitControl:SetHidden(true)
			else
				local iconControl = traitControl.icon or traitControl  -- For unlabeled trait controls, the control is the icon
				traitControl:SetHidden(false)
				
				local label = traitControl.label
				local traitName = recipeData.traits[i]
				local traitIcon = traitIcons[traitName]
				if traitName then
					if label then
						label:SetText(traitName)
					end
				   GAMEPAD_ALCHEMY:SetupTraitIcon(iconControl, traitName, traitIcon)
				end
				if label then
					ZO_ItemSlot_SetupTextUsableAndLockedColor(label, recipeData.meetsUsageRequirement, not recipeData.meetsUsageRequirement)
				end
			end
		end
	end
	local function SetupSaveListEntry(control, data, selected, selectedDuringRebuild, enabled, activated)
		ZO_SharedGamepadEntry_OnSetup(control, data, selected, selectedDuringRebuild, enabled, activated)
		control.selectedItems:SetHidden(not data.meetsUsageRequirement or not selected)
		control:GetNamedChild("Label"):SetFont("ZoFontWinH3")
		control:GetNamedChild("Label"):SetWidth(300)
		if selected then
			SetupTrait(control.selectedItems.traits, data)
			control.selectedItems:SetHeight(30 * #data.traits)
		end
		
		ZO_ItemSlot_SetupTextUsableAndLockedColor(control, data.meetsUsageRequirement, isLocked(data))

	end
	
	self.list:AddDataTemplate("IJAEA_GamepadSavedAlchemyListTemplate", SetupSaveListEntry, ZO_GamepadMenuEntryTemplateParametricListFunction)
	self.list:AddDataTemplateWithHeader("IJAEA_GamepadSavedAlchemyListTemplate", SetupSaveListEntry, ZO_GamepadMenuEntryTemplateParametricListFunction, nil, "ZO_GamepadMenuEntryHeaderTemplate")
end

function IJAEA_GamepadSavedAlchemyList:Refresh()
	local savedAlchemyRecipes = IJAWH.savedVariables.savedAlchemyRecipes
	if not savedAlchemyRecipes then return end
	
	self.list:Clear()
	
	local lastBestItemCategoryName
	for k,data in pairs(savedAlchemyRecipes) do
		local icon = data.icon
		local name = data.name
		local entryData = ZO_GamepadEntryData:New(name, icon)
		
		entryData.name = data.name
		entryData.itemLink = data.itemLink
		entryData.solventType = data.solventType
		entryData.filterType = data.filterType
		entryData.traits = data.traits
		entryData.recipeData = data.recipeData
		entryData.meetsUsageRequirement = meetsUsageRequirement(data)
		
--		if entryData.meetsUsageRequirement or not IJAWH.savedVariables.hideSaves then
		if not IJAWH.savedVariables.hideSaves then
			if data.solventType ~= lastBestItemCategoryName then
				lastBestItemCategoryName = data.solventType

				entryData:SetHeader(lastBestItemCategoryName)
				self.list:AddEntry("IJAEA_GamepadSavedAlchemyListTemplateWithHeader", entryData)
			else
				self.list:AddEntry("IJAEA_GamepadSavedAlchemyListTemplate", entryData)
			end
		end
	end
	self.list:Commit()
end

-------------------------------------
-- Keyboard list
-------------------------------------
function IJAEA_KeyboardSavedAlchemy:InitSaveList()
	self.control = IJAEA_KeyboardSavedAlchemyTopLevel
	local saves = self.control:GetNamedChild("Saves")
	self.saves = IJAEA_KeyboardSavedAlchemyList:New(self, saves)
end

function IJAEA_KeyboardSavedAlchemy:InitKeybindStripDescriptors()
	self.saveKeybindButton = 
	{
		alignment = KEYBIND_STRIP_ALIGN_CENTER,
		name = "Save",
		keybind = "UI_SHORTCUT_TERTIARY",
		visible = function()
			return true
		end,
		enabled = function()
			return isSaveButtonEnabled()
		end,
		callback = function()
			saveCurrentRecipes(IJAWH.recipeList.list)
			
			self.saves:PerformFullRefresh()
		end,
	}
end
	
IJAEA_KeyboardSavedAlchemyList = ZO_CallbackObject:Subclass()

function IJAEA_KeyboardSavedAlchemyList:New(owner, control)
	return IJAEA_KeyboardSavedAlchemyList:Initialize(owner, control)
end

local MENU_BAR_DATA =
{
	initialButtonAnchorPoint = RIGHT,
	buttonTemplate = "ZO_CraftingInventoryTab",
	normalSize = 51,
	downSize = 64,
	buttonPadding = -15,
	animationDuration = 180,
}

function IJAEA_KeyboardSavedAlchemyList:SetFilters(filterData)
	if not self.tabs then
		self.tabs = self.control:GetNamedChild("Tabs")
		self.activeTab = self.control:GetNamedChild("TabsActive")
		ZO_MenuBar_SetData(self.tabs, MENU_BAR_DATA)
		ZO_CraftingUtils_ConnectMenuBarToCraftingProcess(self.tabs)
	else
		ZO_MenuBar_ClearButtons(self.tabs)
	end
	for _, data in ipairs(filterData) do
		ZO_MenuBar_AddButton(self.tabs, data)
	end
end

function IJAEA_KeyboardSavedAlchemyList:Initialize(owner, control)
	self.control = control
	self.owner = owner
	ZO_InventoryInfoBar_ConnectStandardBar(control:GetNamedChild("InfoBar"))
	self:InitializeList()

    local sortByHeaderControl = control:GetNamedChild("SortBy")
    local sortHeaders = ZO_SortHeaderGroup:New(sortByHeaderControl, true)
    local function OnSortHeaderClicked(key, order)
        self:ChangeSort(key, order)
    end
	sortHeaders:RegisterCallback(ZO_SortHeaderGroup.HEADER_CLICKED, OnSortHeaderClicked)
    sortHeaders:AddHeadersFromContainer()
    sortHeaders:SelectHeaderByKey("name", ZO_SortHeaderGroup.SUPPRESS_CALLBACKS)
    self.sortHeaders = sortHeaders
    self.sortOrder = ZO_SORT_ORDER_UP
    self.sortKey = "name"
    self.noDragging = true


	local function CreateNewTabFilterData(filterType, name, normal, pressed, highlight, disabled, visible)
		return {
			activeTabText = name,
			tooltipText = name,
			descriptor = filterType,
			normal = normal,
			pressed = pressed,
			highlight = highlight,
			disabled = disabled,
			visible = visible,
			callback = function(tabData) self:ChangeFilter(tabData) end,
		}
	end

	self:SetFilters{
		CreateNewTabFilterData(2, "Poisons", 
		"/esoui/art/tradinghouse/tradinghouse_potions_poisonsolvent_up.dds", "/esoui/art/tradinghouse/tradinghouse_potions_poisonsolvent_down.dds", "/esoui/art/tradinghouse/tradinghouse_potions_poisonsolvent_over.dds", "/esoui/art/tradinghouse/tradinghouse_potions_poisonsolvent_disabled.dds"),
		CreateNewTabFilterData(1, "Potions", "EsoUI/Art/Crafting/alchemy_tabIcon_solvent_up.dds", "EsoUI/Art/Crafting/alchemy_tabIcon_solvent_down.dds", "EsoUI/Art/Crafting/alchemy_tabIcon_solvent_over.dds", "EsoUI/Art/Crafting/alchemy_tabIcon_solvent_disabled.dds"),
		CreateNewTabFilterData(nil, "All", "EsoUI/Art/Inventory/inventory_tabIcon_all_up.dds", "EsoUI/Art/Inventory/inventory_tabIcon_all_down.dds", "EsoUI/Art/Inventory/inventory_tabIcon_all_over.dds", "EsoUI/Art/Inventory/inventory_tabIcon_all_disabled.dds"),
	}
	self:SetNoItemLabelHidden(false)
	
	self.sortOrder = ZO_SORT_ORDER_DOWN
    self.sortKey = "filterType"
	
    self.sortHeaders:SelectHeaderByKey(self.sortKey, ZO_SortHeaderGroup.SUPPRESS_CALLBACKS, not ZO_SortHeaderGroup.FORCE_RESELECT, self.sortOrder)
	
	self:HandleDirtyEvent()
	return self
end

function IJAEA_KeyboardSavedAlchemyList:HandleDirtyEvent()
	if self.control:IsHidden() or ZO_CraftingUtils_IsPerformingCraftProcess() then
		self.dirty = true
	else
		self:PerformFullRefresh()
	end
end

function IJAEA_KeyboardSavedAlchemyList:InitializeList()
	self.list = self.control:GetNamedChild("List")
	self.noItemsLabel = self.control:GetNamedChild("NoItemsLabel")
	self:AddListDataTypes()
end

function IJAEA_KeyboardSavedAlchemy:SetActiveFilterByDescriptor(descriptor)
	if descriptor then
		ZO_MenuBar_SelectDescriptor(self.saves.tabs, descriptor)
	else
		ZO_MenuBar_SelectDescriptor(self.saves.tabs, nil)
	end
end

local USE_LOWERCASE_NUMBER_SUFFIXES = false
function IJAEA_ItemSlot_SetupSlotBase(slotControl, iconFile, visible)
	local showSlot = true
	if type(visible) == "function" then
		showSlot = visible()
	elseif visible ~= nil then
		showSlot = visible
	end
	slotControl:SetHidden(not showSlot)
	
	local iconControl = GetControl(slotControl, "Icon")
	if iconControl then
		if iconFile == nil or iconFile == "" then
			iconControl:SetHidden(true)
		else
			iconControl:SetTexture(iconFile)
			iconControl:SetHidden(false)
		end
	end
end
function IJAEA_KeyboardSavedAlchemyList_SetupUsableAndLockedColor(slotControl, meetsUsageRequirement, locked)
	ZO_ItemSlot_SetupTextUsableAndLockedColor(GetControl(slotControl, "Name"), meetsUsageRequirement, locked)
	ZO_ItemSlot_SetupUsableAndLockedColor(GetControl(slotControl, "Button"), meetsUsageRequirement, locked)
end
function IJAEA_KeyboardSavedAlchemyList_SetupSlot(slotControl, data)
	IJAEA_ItemSlot_SetupSlotBase(GetControl(slotControl, "Button"), data.icon, true)
	IJAEA_KeyboardSavedAlchemyList_SetupUsableAndLockedColor(slotControl, meetsUsageRequirement(data), isLocked(data))
end

function IJAEA_KeyboardSavedAlchemyList:SetMousedOverRow(slot)
	self.mousedOverSlot = slot
end

function IJAEA_KeyboardSavedAlchemyList:IsLocked(data)	--------------------
    return not meetsUsageRequirement(data)
end

local function onSelected(control, button, data)
	if button == 1 then		-- left-click
		addToRecipeList(data)
		control:HandleDirtyEvent()
	elseif button == 2 then	-- right-click
		deleteSavedData(data)
	end
end

function IJAEA_KeyboardSavedAlchemyList:GetDefaultTemplateSetupFunction()
	return function(rowControl, data)
		rowControl.owner = self
		local row = rowControl:GetNamedChild("Button")
		row.name = row.name or rowControl:GetNamedChild("Name")
		
		row.name:SetText(data.name)
		
		row.name:SetWidth(rowControl:GetRight())
		
		IJAEA_KeyboardSavedAlchemyList_SetupSlot(rowControl, data)
		row.tooltipAnchor = rowControl
		
		row.owner = self
		ZO_UpdateTraitInformationControlIcon(rowControl, data)
		
		self.noDragging = true
		if self.noDragging then
			rowControl:SetHandler("OnDragStart", nil)
			rowControl:SetHandler("OnReceiveDrag", nil)
		end
		
		rowControl:SetHandler("OnMouseUp", function(_, button)
			onSelected(self, button, data)
		end)
		
		ZO_ItemSlot_SetupTextUsableAndLockedColor(row, data.meetsUsageRequirement, isLocked(data))
	end
end

function IJAEA_KeyboardSavedAlchemyList:AddListDataTypes()
	local defaultSetup = self:GetDefaultTemplateSetupFunction()
 	local function SetupTrait(controls, data)
		local numTraits = #data.traits
		for i, traitControl in ipairs(controls) do
			if i > numTraits then
				traitControl:SetHidden(true)
			else
				traitControl:SetHidden(false)
				local traitName = data.traits[i]
				local traitIcon = traitIcons[traitName]
				
				if traitName and traitName ~= "" then
                    traitControl.label:SetColor(GetInterfaceColor(INTERFACE_COLOR_TYPE_ITEM_TOOLTIP, ITEM_TOOLTIP_COLOR_ACCENT))
					traitControl.label:SetText(traitName)
					
					ALCHEMY:SetupTraitIcon(traitControl.icon, traitName, traitIcon)
					traitControl.icon:SetHidden(false)
				else
					traitControl.label:SetColor(GetInterfaceColor(INTERFACE_COLOR_TYPE_ITEM_TOOLTIP, ITEM_TOOLTIP_COLOR_INACTIVE_BONUS))
					traitControl.label:SetText(GetString(SI_CRAFTING_UNKNOWN_NAME))
					traitControl.icon:SetHidden(true)
				end
				
				traitControl:SetHandler("OnMouseUp", function(_, button)
					onSelected(self, button, data)
				end)
				
				ZO_ItemSlot_SetupTextUsableAndLockedColor(traitControl.label, data.meetsUsageRequirement, isLocked(data))
			end
		end
	end
	local function SetupSaveListEntry(rowControl, data)
		defaultSetup(rowControl, data)
		SetupTrait(rowControl.traits, data)
	end

	local LIST_TYPE = 1
	ZO_ScrollList_AddDataType(self.list, LIST_TYPE, "IJAEA_KeyboardSavedAlchemyListTemplate", 108, SetupSaveListEntry)

end

function IJAEA_KeyboardSavedAlchemyList:SetNoItemLabelText(text)
	self.noItemsLabel:SetText(text)
end
function IJAEA_KeyboardSavedAlchemyList:SetNoItemLabelHidden(isHidden)
	self.noItemsLabel:SetHidden(isHidden)
end

function IJAEA_KeyboardSavedAlchemyList:HandleDirtyEvent()
	if self.control:IsHidden() or ZO_CraftingUtils_IsPerformingCraftProcess() then
		self.dirty = true
	else
		self:PerformFullRefresh()
	end
end

function IJAEA_KeyboardSavedAlchemyList:ChangeFilter(filterData)
	ZO_CraftingInventory.ChangeFilter(self, filterData)
	self.filterType = filterData.descriptor
	self.sortHeaders:SetHeadersHiddenFromKeyList({ filterType = self.filterType ~= nil }, true)
	if self.filterType == 2 then
		self:SetNoItemLabelText("No saved poisons")
	elseif self.filterType == 1 then
		self:SetNoItemLabelText("No saved potions")
	else
		self:SetNoItemLabelText("No saved potions or poisons")
	end
	self:SetNoItemLabelHidden(false)
	self:HandleDirtyEvent()
end

function IJAEA_KeyboardSavedAlchemyList:AddItemData(data)
	local newData = 
	{
		name = data.name,
		icon = data.icon,

		itemLink = data.itemLink,
		solventType = data.solventType,
		filterType = data.filterType,
		traits = data.traits,
		recipeData = data.recipeData,
		meetsUsageRequirement = meetsUsageRequirement(data)
	}
	
	local newScrollData = ZO_ScrollList_CreateDataEntry(1, newData)
	return newScrollData
end

function IJAEA_KeyboardSavedAlchemyList_DoesAlchemyItemPassFilter(data, filterType)
	if filterType == nil then
		return true
	end
	return filterType == data.filterType
end

function IJAEA_KeyboardSavedAlchemyList:RefreshFilters()
	ZO_MenuBar_UpdateButtons(self.tabs)
	if not ZO_MenuBar_GetSelectedDescriptor(self.tabs) then
		ZO_MenuBar_SelectLastVisibleButton(self.tabs, true)
	end
end

function IJAEA_KeyboardSavedAlchemyList:SortData()
	local scrollData = ZO_ScrollList_GetDataList(self.list)
	self.sortFunction = self.sortFunction or function(entry1, entry2)
		if entry1.typeId == entry2.typeId then
			return ZO_TableOrderingFunction(entry1.data, entry2.data, self.sortKey, SAVED_LIST_SORT, self.sortOrder)
		end
		return entry1.typeId < entry2.typeId
	end
	table.sort(scrollData, self.sortFunction)
end

function IJAEA_KeyboardSavedAlchemyList:ChangeSort(sortKey, sortOrder)
    self.sortKey = sortKey
    self.sortOrder = sortOrder
    self:SortData()
    ZO_ScrollList_Commit(self.list)
end

function IJAEA_KeyboardSavedAlchemyList:PerformFullRefresh()
	self.dirty = false
	if not self.performingFullRefresh then
		self.performingFullRefresh = true
		ZO_ScrollList_Clear(self.list)
		self:RefreshFilters()
		self:Refresh(ZO_ScrollList_GetDataList(self.list))
		self:SortData()
		ZO_ScrollList_Commit(self.list)
		self.performingFullRefresh = false
	end
end

function IJAEA_KeyboardSavedAlchemyList:EnumerateInventorySlotsAndAddToScrollData(filterFunction, filterType, data)
	local savedAlchemyRecipes = IJAWH.savedVariables.savedAlchemyRecipes

	for index, itemData in pairs(savedAlchemyRecipes) do
		local newData = {}
		if not filterFunction or filterFunction(itemData, filterType) then
			local newData = self:AddItemData(itemData)
--			if newData.data.meetsUsageRequirement or not IJAWH.savedVariables.hideSaves then
			if not IJAWH.savedVariables.hideSaves then
				data[#data + 1] = newData
			end
		end
	end

end

function IJAEA_KeyboardSavedAlchemyList:Refresh(data)
	self:EnumerateInventorySlotsAndAddToScrollData(IJAEA_KeyboardSavedAlchemyList_DoesAlchemyItemPassFilter, self.filterType, data)
	self:SetNoItemLabelHidden(#data > 0)
end

-------------------------------------
-- Easy Alchemy
-------------------------------------
IsJustaEasyAlchemy = {}
function IsJustaEasyAlchemy:CreateAlchemyPanel()
    local IsJustaEasyAlchemyTLW = CreateTopLevelWindow("IsJustaEasyAlchemyHListTLW")
    IsJustaEasyAlchemyTLW:SetDimensions(900, 100)
	
	IsJustaEasyAlchemyTLW:SetHidden(true)
	
	IsJustaEasyAlchemy.AlchemyTLW = IsJustaEasyAlchemyTLW
	
	local IsJustaEasyAlchemyHList = CreateControlFromVirtual("IsJustaEasyAlchemy_AlchemyPanel", IsJustaEasyAlchemyTLW, "IsJustaEasyAlchemy_AlchemyPanel")
	
	IsJustaEasyAlchemyHList:SetDimensions(900, 100)

    IsJustaEasyAlchemyHList:SetScale(.5)
	IsJustaEasyAlchemy.AlchemyHList = IsJustaEasyAlchemyHList
	
	IsJustaEasyAlchemy.AlchemyHList.pattern = {[1] = nil, [2] = nil, [3] = nil, [4] = nil}
	IsJustaEasyAlchemy.AlchemyHList.Trait = {}
	
	IsJustaEasyAlchemy.LoadignProgress = IsJustaEasyAlchemy_LoadingProgress
    IsJustaEasyAlchemy.LoadignProgressAnimation = ANIMATION_MANAGER:CreateTimelineFromVirtual("LoadingAnimation", self.LoadignProgress)
	
	IsJustaEasyAlchemy_LoadingProgress:SetAnchor(CENTER, GuiRoot, nil, 0, 0)
	ZO_AlchemyTopLevel:BringWindowToTop()

	IsJustaEasyAlchemy.LoadignProgressAnimation:SetHandler("OnStart", function(animation)
		IJAEA_SavedAlchemy:UpdateKeybindButton()
	end)
	IsJustaEasyAlchemy.LoadignProgressAnimation:SetHandler("OnStop", function(animation)
		zo_callLater(function() IJAEA_SavedAlchemy:UpdateKeybindButton() end, 50)
	end)
end	

function IsJustaEasyAlchemy:UpdatePanel()
	local resultLink
	IJAWH:UpdateSolvent()
	if IsInGamepadPreferredMode() then
		resultLink = GetAlchemyResultingItemLink(GAMEPAD_ALCHEMY:GetAllCraftingBagAndSlots()):gsub("%|H1", "|H0")
	else
		resultLink = GetAlchemyResultingItemLink(ALCHEMY:GetAllCraftingBagAndSlots()):gsub("%|H1", "|H0")
	end
	
	if resultLink ~= "" then
		IsJustaEasyAlchemy.Unknown = false
	else
		if IJAWH_EASYALCHEMY_OUT then
			resultLink = GetString(SI_TRADESKILLRESULT132)
		else
			resultLink = zo_strformat(GetString(SI_ALCHEMY_UNKNOWN_RESULT),IsJustaEasyAlchemy.AlchemyHList.pattern[1])
			IsJustaEasyAlchemy.Unknown = true
			IJAWH_EASYALCHEMY_OUT = false
		end
	end
	
	IJAWH:EnableReagentPanel(true)
	IJAWH:showCraftPannel(resultLink)
end
		
function IsJustaEasyAlchemy:SetupSelecters()
	BufferTable = {}
	local NO_LEADING_EDGE = false
	
	local duration = 1000
	local function onStartLookup()
		IsJustaEasyAlchemy.LoadignProgressAnimation:PlayForward()
		IsJustaEasyAlchemy.LoadignProgress:StartCooldown(duration, duration, CD_TYPE_RADIAL, CD_TIME_TYPE_TIME_REMAINING, NO_LEADING_EDGE)
	end

	local function onEndLookup()
		IsJustaEasyAlchemy.LoadignProgressAnimation:PlayBackward()
		if IJAWH_CurrentWrit.recipeData then
			IJAWH:setStationForWrit()
			IsJustaEasyAlchemy:UpdatePanel()
		end
	end	
	
	local function OnUpdateHandler()	
		if not IJAWH.activeEvents.UpdateTicRegistered and IsJustaEasyAlchemy.AlchemyHList.pattern[2] ~= nil then 
			EVENT_MANAGER:RegisterForUpdate("IJAWH_UpdateTic", 100, OnUpdateHandler)
			EVENT_MANAGER:RegisterForUpdate("IJAWH_RepeatProgress", duration+10, onStartLookup)
			IJAWH.activeEvents.UpdateTicRegistered = true
			onStartLookup()
		end
		
		if not IJAWH:BufferReached("wait", 4) then return end
		IsJustaEasyAlchemy:buildCraftString()
		EVENT_MANAGER:UnregisterForUpdate("IJAWH_UpdateTic")
		EVENT_MANAGER:UnregisterForUpdate("IJAWH_RepeatProgress")
		IJAWH.activeEvents.UpdateTicRegistered = false
		onEndLookup()
	end

    local function SetupFunction_Trait3(control, data, selected, selectedDuringRebuild, enabled)
		IsJustaEasyAlchemy.AlchemyHList.pattern[4] = data.trait
		OnUpdateHandler(data)
		
    end
	
	local function OnSelectedpatternChanged_Trait3(selectedData, oldData, selectedDuringRebuild)
		if selectedData then
			IsJustaEasyAlchemy.AlchemyHList.trait3Label:SetText(selectedData.trait)
			IsJustaEasyAlchemy.AlchemyHList.pattern[4] = selectedData.trait
		end	
		OnUpdateHandler(selectedData)
    end
	   
    local trait3Hlist = ZO_HorizontalScrollList:New(IsJustaEasyAlchemy.AlchemyHList.trait3Control, "IsJustaEasyAlchemy_HList_SlotTemplate", 3, SetupFunction_Trait3)
    trait3Hlist:SetOnSelectedDataChangedCallback(function(selectedData, oldData, selectedDuringRebuild)
        OnSelectedpatternChanged_Trait3(selectedData, oldData, selectedDuringRebuild)
    end)
	
	trait3Hlist.displayEntryType = ZO_HORIZONTAL_SCROLL_LIST_ANCHOR_ENTRIES_AT_FIXED_DISTANCE
    trait3Hlist.offsetBetweenEntries = 100
	
	IsJustaEasyAlchemy.AlchemyHList.Trait[3] = trait3Hlist
	IsJustaEasyAlchemy.AlchemyHList.Trait[3]:AddEntry({trait = ""})
	IsJustaEasyAlchemy.AlchemyHList.Trait[3]:Commit()
	
    local function SetupFunction_Trait2(control, data, selected, selectedDuringRebuild, enabled)
		self:SetEffectList(3,data)
		IsJustaEasyAlchemy.AlchemyHList.pattern[3] = data.trait
		IsJustaEasyAlchemy.AlchemyHList.pattern[4] = nil
		OnUpdateHandler(data)
		
    end
	
    local function OnSelectedpatternChanged_Trait2(selectedData, oldData, selectedDuringRebuild)
	
		if selectedData then
			IsJustaEasyAlchemy.AlchemyHList.trait2Label:SetText(selectedData.trait)
			IsJustaEasyAlchemy.AlchemyHList.trait3Label:SetText("")
			self:SetEffectList(3,selectedData)
		IsJustaEasyAlchemy.AlchemyHList.pattern[3] = selectedData.trait
		end
		OnUpdateHandler(selectedData)
		
    end
	
    local trait2Hlist = ZO_HorizontalScrollList:New(IsJustaEasyAlchemy.AlchemyHList.trait2Control, "IsJustaEasyAlchemy_HList_SlotTemplate", 3, SetupFunction_Trait2)
    trait2Hlist:SetOnSelectedDataChangedCallback(function(selectedData, oldData, selectedDuringRebuild)
        OnSelectedpatternChanged_Trait2(selectedData, oldData, selectedDuringRebuild)
    end)
	
	trait2Hlist.displayEntryType = ZO_HORIZONTAL_SCROLL_LIST_ANCHOR_ENTRIES_AT_FIXED_DISTANCE
    trait2Hlist.offsetBetweenEntries = 100
	
	IsJustaEasyAlchemy.AlchemyHList.Trait[2] = trait2Hlist
	IsJustaEasyAlchemy.AlchemyHList.Trait[2]:AddEntry({trait = ""})
	IsJustaEasyAlchemy.AlchemyHList.Trait[2]:Commit()
	
    local function SetupFunction_Trait1(control, data, selected, selectedDuringRebuild, enabled)
		self:SetEffectList(2,data)
		IsJustaEasyAlchemy.AlchemyHList.pattern[2] = data.trait
		IsJustaEasyAlchemy.AlchemyHList.pattern[3] = nil
		IsJustaEasyAlchemy.AlchemyHList.pattern[4] = nil
    end
	
    local function OnSelectedpatternChanged_Trait1(selectedData, oldData, selectedDuringRebuild)
		if selectedData then
			IsJustaEasyAlchemy.AlchemyHList.trait1Label:SetText(selectedData.trait)
			IsJustaEasyAlchemy.AlchemyHList.trait3Label:SetText("")
			self:SetEffectList(2,selectedData)
			IsJustaEasyAlchemy.AlchemyHList.pattern[2] = selectedData.trait
		end 
		OnUpdateHandler()
		
    end
	
    local trait1Hlist = ZO_HorizontalScrollList:New(IsJustaEasyAlchemy.AlchemyHList.trait1Control, "IsJustaEasyAlchemy_HList_SlotTemplate", 3, SetupFunction_Trait1)
    trait1Hlist:SetOnSelectedDataChangedCallback(function(selectedData, oldData, selectedDuringRebuild)
        OnSelectedpatternChanged_Trait1(selectedData, oldData, selectedDuringRebuild)
    end)
	
	trait1Hlist.displayEntryType = ZO_HORIZONTAL_SCROLL_LIST_ANCHOR_ENTRIES_AT_FIXED_DISTANCE
    trait1Hlist.offsetBetweenEntries = 100
	
	IsJustaEasyAlchemy.AlchemyHList.Trait[1] = trait1Hlist
	IsJustaEasyAlchemy.AlchemyHList.Trait[1]:AddEntry({trait = ""})
	IsJustaEasyAlchemy.AlchemyHList.Trait[1]:Commit()
	

    local function SetupFunction(control, data, selected, selectedDuringRebuild, enabled)
		IsJustaEasyAlchemy.AlchemyHList.pattern[1] = data.solvent
    end
	
    local function OnSelectedpatternChanged(selectedData, oldData, selectedDuringRebuild)	
		IsJustaEasyAlchemy.AlchemyHList.solventLabel:SetText(selectedData.solvent)
		
		IsJustaEasyAlchemy.AlchemyHList.pattern[1] = selectedData.solvent
		IsJustaEasyAlchemy.AlchemyHList.pattern[2] = nil
		IsJustaEasyAlchemy.AlchemyHList.pattern[3] = nil
		IsJustaEasyAlchemy.AlchemyHList.pattern[4] = nil
		
		
		self:SetEffectList(1,selectedData)
		OnUpdateHandler()
    end
	
    local solventHlist = ZO_HorizontalScrollList:New(IsJustaEasyAlchemy.AlchemyHList.solventControl, "IsJustaEasyAlchemy_HList_SlotTemplate", 3, SetupFunction)
    solventHlist:SetOnSelectedDataChangedCallback(function(selectedData, oldData, selectedDuringRebuild)
        OnSelectedpatternChanged(selectedData, oldData, selectedDuringRebuild)
    end)
	
	solventHlist.displayEntryType = ZO_HORIZONTAL_SCROLL_LIST_ANCHOR_ENTRIES_AT_FIXED_DISTANCE
    solventHlist.offsetBetweenEntries = 100
	IsJustaEasyAlchemy.AlchemyHList.solventType = solventHlist
end

function IsJustaEasyAlchemy:InitialiseSolventList()
	IsJustaEasyAlchemy.AlchemyHList.solventType:Clear()
	for i=1, 2 do
		IsJustaEasyAlchemy.AlchemyHList.solventType:AddEntry({solvent = IJAWH.alchemyVariatons[i].solvent, Table = IJAWH.alchemyVariatons[i]})
	end
	IsJustaEasyAlchemy.AlchemyHList.solventType:Commit()
end

function IsJustaEasyAlchemy:SetSolventLevel(isPoison)
    local solventRank = IJAWH:GetSkillRank(CRAFTING_TYPE_ALCHEMY, 1)

    local solventList
    if isPoison == "Poison" then
        solventList = {[1] = {"I", "II"}, [2] = "III", [3] = "IV", [4] = "V", [5] = "VI", [6] = "VII", [7] = "VIII", [8] = "IX"}
	else
        solventList = {[1] = {"Sip","Tincture"},[2] = "Dram",[3] = "Potion",[4] = "Solution",[5] = "Elixir", [6] = "Panacea", [7] = "Distillate", [8] = "Essence"}
    end
	local solvent = solventList[solventRank]
	if type(solvent) == "table" then	-- for alchemy level 1
		local playerLevel = GetUnitLevel("player")
		solvent = playerLevel < 10 and solvent[1] or solvent[2]
	end
	
	return solvent
end

function IsJustaEasyAlchemy:buildCraftString()
	local isPoison = IJAWH:isPoison(IsJustaEasyAlchemy.AlchemyHList.pattern[1])
	local pattern = IsJustaEasyAlchemy:ConvertTraitNames(isPoison)
	local traits = {}
	local craftLine = nil
	
	if  IsInGamepadPreferredMode() then
		for i, slot in ipairs(GAMEPAD_ALCHEMY.reagentSlots) do		
			slot:SetItem(nil, nil, suppressSound, ignoreUsabilityRequirement)
		end
	else
		for i, slot in ipairs(ALCHEMY.reagentSlots) do		
			slot:SetItem(nil, nil, suppressSound, ignoreUsabilityRequirement)
		end
	end
	if pattern[2] ~= nil then
		if isPoison == "Poison" then
			craftLine =  "Craft " .. pattern[2] .. " Poison " .. tostring(self:SetSolventLevel(isPoison)) .. ":"
		else
			craftLine =  "Craft " .. tostring(self:SetSolventLevel(isPoison)) .. " of " ..  pattern[2] .. ":"
		end
		
		if pattern[3] ~= nil then traits[#traits + 1] = pattern[3] end
		if pattern[4] ~= nil then traits[#traits + 1] = pattern[4] end
		
		IsJustaEasyAlchemy.AlchemyHList.List = {craftLine = craftLine, traits = traits}
		local parameterList = self:GetAlchemyPanel()
		return parameterList
	end

end

function IsJustaEasyAlchemy:GetAlchemyPanel()
	GAMEPAD_ALCHEMY_CREATION_SCENE:UnregisterCallback("StateChange", IJAWH.onStateChangedCallback)
	local patternList = tostring(IsJustaEasyAlchemy.AlchemyHList.List.craftLine)
	
	local traits = IsJustaEasyAlchemy.AlchemyHList.List.traits
	if patternList ~= nil then
	
		local qName = IJAWH_CurrentWrit.qName
		local maximum, _, _, parameterList, solventLink = IJAWH:GetAlchemyDetails(nil, nil, 1, qName, patternList, 1, traits)
		local pattern = IJAWH:ConvertedJournalAlchemyCondition(patternList)
		return parameterList
	end
end

function IsJustaEasyAlchemy:SetEffectList(key,data)
	IsJustaEasyAlchemy.AlchemyHList.Trait[key]:Clear()
	if data.Table ~= nil then
		for i=1, #data.Table do
			IsJustaEasyAlchemy.AlchemyHList.Trait[key]:AddEntry({trait = data.Table[i].trait, Table = data.Table[i]})
		end
		IsJustaEasyAlchemy.AlchemyHList.Trait[key]:Commit()
	end
end

function IsJustaEasyAlchemy:PurgeSelectors()
	IsJustaEasyAlchemy.AlchemyHList.pattern = {[1] = nil, [2] = nil, [3] = nil, [4] = nil}
	IsJustaEasyAlchemy.AlchemyHList.List = {}
	for i=1, 3 do IsJustaEasyAlchemy.AlchemyHList.Trait[i]:Clear() end
	IsJustaEasyAlchemy.AlchemyHList.solventType:Clear()
end

local anchor = ZO_Anchor:New(TOPLEFT, ZO_AlchemyTopLevelSlotContainer, TOPLEFT, -30, 35)
local function SetAnchorOffsetX(control, offsetX)
	anchor:SetOffsets(offsetX)                
	anchor:Set(IsJustaEasyAlchemy_AlchemyPanel)  
end

local function applyStyle()
	ApplyTemplateToControl(IsJustaEasyAlchemy_LoadingProgress, ZO_GetPlatformTemplate("IsJustaEasyAlchemy_LoadingProgress"))
	ApplyTemplateToControl(IsJustaEasyAlchemy.AlchemyHList, ZO_GetPlatformTemplate("IsJustaEasyAlchemy_AlchemyPanel"))

	local thirdSlotLocked = true
	if ZO_Alchemy_IsThirdAlchemySlotUnlocked() then thirdSlotLocked = false end
	
	IsJustaEasyAlchemy.AlchemyHList.trait3Control:SetHidden(thirdSlotLocked)
	
	if not IsInGamepadPreferredMode() then
		local x = thirdSlotLocked and 80 or -30
		SetAnchorOffsetX(IsJustaEasyAlchemy_AlchemyPanel, x)
	end
end

function IsJustaEasyAlchemy:OnAlchemyStation()
	if not IsJustaEasyAlchemy.isEasyAlchemy then return false end
	if not IsInGamepadPreferredMode() then KEYBIND_STRIP:UpdateKeybindButtonGroup(ALCHEMY.keybindStripDescriptor) end
	
	if not IsJustaEasyAlchemy.AlchemyHList.solventType then 
		self:SetupSelecters()
	end
	IsJustaEasyAlchemy.AlchemyTLW:SetHidden(false)
	IsJustaEasyAlchemy:InitialiseSolventList()
	applyStyle()
	
	IJAWH.craftPanel.header:SetText(GetString(SI_IJAWH_EASYALCHEMY))
	IJAWH.craftPanel.icon:SetTexture(IJAWH.iconList[GetCraftingInteractionType()])
	
	if not IJAWH.savedVariables.tutorials.IJAWH_TUTORIAL_EASYALCHEMY then 
		IJAWH:DialogueQueue("IJAWH_TUTORIAL_EASYALCHEMY")
	end
	showHidePanels(1)
end

function IsJustaEasyAlchemy:OnCloseAlchemyStation()
	if IsJustaEasyAlchemy.isEasyAlchemy then
		for i=1, #IJAWH.writData do
			if string.match(IJAWH.writData[i].qName, GetString(SI_IJAWH_EASYALCHEMY)) then
				table.remove(IJAWH.writData,i)
			end
		end
		
		table.remove(IJAWH.writData, IJAWH_WD_INDEX)
		EVENT_MANAGER:UnregisterForUpdate("IJAWH_UpdateTic")
		EVENT_MANAGER:UnregisterForUpdate("IJAWH_RepeatProgress")
		IJAWH.activeEvents.UpdateTicRegistered = false
		
		IsJustaEasyAlchemy.LoadignProgressAnimation:PlayBackward()
		IsJustaEasyAlchemy.isEasyAlchemy = false 
	end
end

function IsJustaEasyAlchemy:Initialize()
	self:CreateAlchemyPanel()	
--------------
	IJAEA_SavedAlchemy:Init()
--------------
	local deleteSavedDataDialogue =
	{
		gamepadInfo = { dialogType = GAMEPAD_DIALOGS.BASIC, allowShowOnNextScene = true },
		title = { text = GetString(SI_IJAWH_SAVEDALCHEMY_CONFIRMDELETE_TITLE) },
		mainText = { text =  function(dialog)
			if dialog.data then
				local nameColor = GetItemQualityColor(GetItemLinkDisplayQuality(dialog.data.itemLink))
				local itemName = nameColor:Colorize(dialog.data.recipeName)
				return zo_strformat(GetString(SI_IJAWH_SAVEDALCHEMY_CONFIRMDELETE_TEXT), itemName)
			else
				return GetString(SI_IJAWH_INVALIDRECIPE)
			end
		end},
		buttons = {
			{
				text = SI_DIALOG_YES,
				callback = function(dialog)
					local savedAlchemyRecipes = IJAWH.savedVariables.savedAlchemyRecipes
					if dialog.data then	
						local mode = 0
						table.remove(savedAlchemyRecipes, dialog.data.index)
						if IsInGamepadPreferredMode() then
							IJAEA_GamepadSavedAlchemy.saves:Refresh()
							mode = GAMEPAD_ALCHEMY.modeList:GetTargetData().mode
						else
							IJAEA_KeyboardSavedAlchemyList:HandleDirtyEvent()
							mode = ALCHEMY.mode
						end
						showHidePanels(mode)
					end
				end
			},
			{ text = SI_DIALOG_NO }
		}
	}
	ZO_Dialogs_RegisterCustomDialog("IJAWH_DELETE", deleteSavedDataDialogue)
end