IJAWH = {
	displayName = "BETA: |cFF00FFIsJusta|r WritHelper with Easy Alchemy",
	name = "IsJustaWritHelper-Beta",
	version = "4.5.8:beta",
	svVersion = 4.58,

    SI_IJAWH_PRIORITY_BY_STOCK = 1,
    SI_IJAWH_PRIORITY_BY_MANUAL = 2,
    SI_IJAWH_PRIORITY_BY_TTC = 3,
	
	writData = {},
	withdrawItems = {},
	PreviousKeybind = {},
	activeEvents = {},
	craftKeybindButtonDescriptor = {},
	savedCraftingAnchor = {},
	
	selectedStyle = {},
	
	dialogueQueue = {},
	
	LastChecked = 0,
	
	writsPanelFunc = {},
	
	WP = {
		isMinimized = false,
		isCollapsed = false,
		isGrouped = false
	},
	
	DefaultSettings = {
		easyAlchemy = true,
		useMostStyle = true,
		showCraftForWrit = true,
		showWithdrawInChat = true,
		showInBankAlert = true,
		handleWithdraw = true,
		hideWhileMounted = false,
		useRaceStyles = false,
		autoExit = false,
		hideSaves = true,
		autoCraft = false,
		autoAccept = false,
		autoAlchemy = false,
		autoOpenDelay = 2
	}
}
IJAWH.iconList = {
	[1] = "/esoui/art/inventory/inventory_tabicon_craftbag_blacksmithing_up.dds", 	-- CRAFTING_TYPE_BLACKSMITHING
	[2] = "/esoui/art/inventory/inventory_tabicon_craftbag_clothing_up.dds", 		-- CRAFTING_TYPE_CLOTHIER
	[3] = "/esoui/art/inventory/inventory_tabicon_craftbag_enchanting_up.dds", 		-- CRAFTING_TYPE_ENCHANTING
	[4] = "/esoui/art/inventory/inventory_tabicon_craftbag_alchemy_up.dds", 		-- CRAFTING_TYPE_ALCHEMY
	[5] = "/esoui/art/inventory/inventory_tabicon_craftbag_provisioning_up.dds", 	-- CRAFTING_TYPE_PROVISIONING
	[6] = "/esoui/art/inventory/inventory_tabicon_craftbag_woodworking_up.dds", 	-- CRAFTING_TYPE_WOODWORKING
	[7] = "/esoui/art/inventory/inventory_tabicon_craftbag_jewelrycrafting_up.dds" 	-- CRAFTING_TYPE_JEWELRYCRAFTING
}

IJAWH_CurrentWrit = {}
IJAWH_Igdnt_yPos = 0
IJAWH_PANEL_HEIGHT = 60

IJAWH_WITHDRAW_ITEMS = 0

-------------------------------------
-- Helper Functions
-------------------------------------

local function getWitchesType(qIndex)
	for lineId = 1, GetJournalQuestNumConditions(qIndex,1) do
		local condition,current,maximum,_,complete = GetJournalQuestConditionInfo(qIndex,1,lineId)
		if condition ~= '' then
			for k,v in pairs(IJAWH_WITCHES_WRITS) do
				if string.find(condition, k) then
					return v
				end
			end
		end
	end
	return 0
end

local onCraftItemUpdate
local function getCraftedItemLink()
	local recipeData = IJAWH_CurrentWrit.writType == CRAFTING_TYPE_ALCHEMY and IJAWH_CurrentWrit.recipeData[1] or IJAWH_CurrentWrit.recipeData[#IJAWH_CurrentWrit.recipeData]
	if recipeData.itemLink then
		return recipeData.itemLink
	end
end

local function updateIterations(data)
	local itemLink = data.itemLink
	local bagCount, bankCount, craftBagCount = GetItemLinkStacks(itemLink)
	local numPerIteration, maximum = 0 , data.maximum
	
	if IJAWH_CurrentWrit.writType == CRAFTING_TYPE_ALCHEMY then
			local soventBagId, sloventSlotIndex = data.solventSlot.bagId, data.solventSlot.slotIndex
			local solventItemLink  = GetItemLink(soventBagId, sloventSlotIndex)
			numPerIteration = IJAWH:GetAlchemyNumPerIteration(solventItemLink)
			
	elseif IJAWH_CurrentWrit.writType == CRAFTING_TYPE_PROVISIONING then
			local recipeListIndex, recipeIndex = data.recipeListIndex, data.recipeIndex
			numPerIteration = IJAWH:GetProvisioningNumPerIteration(recipeListIndex,recipeIndex)
	end
	
	if bagCount > 0 then
		local numIterations = IJAWH:GetAmountToMake(math.ceil((maximum - bagCount) / numPerIteration))
		return numIterations
	
	else
		return data.numIterations
	end
end

local function getTimeElapsed(lastTime)
	local timeStamp = lastTime
	local elapsedTime = GetTimeStamp() - timeStamp
	return elapsedTime
end

local function canCraft()
	local recipeData = IJAWH_CurrentWrit.recipeData
	if not recipeData[1] then
		return false
	elseif IJAWH_CurrentWrit.writType == CRAFTING_TYPE_ALCHEMY then
		return not ZO_CraftingUtils_IsPerformingCraftProcess() and recipeData[1].func(recipeData[1])
	else
		local i = #recipeData
		return not ZO_CraftingUtils_IsPerformingCraftProcess() and recipeData[i].func(recipeData[i])
	end
end

local function EntryFactory(pool)
	local name = "CraftEntry" .. pool:GetNextControlId()
	local container = IJAWH.craftTLW:CreateControl(name, CT_CONTROL)
	local conditions = container:CreateControl("$(parent)Conditions", CT_LABEL)
	local ingredients = container:CreateControl("$(parent)Ingredients", CT_LABEL)

	conditions:SetFont("ZoFontWinH3")
	conditions:SetWidth(380)
	conditions:SetHorizontalAlignment(TEXT_ALIGN_LEFT)
	ingredients:SetFont("ZoFontWinH3")
	conditions:SetWidth(380)
	ingredients:SetHorizontalAlignment(TEXT_ALIGN_CENTER)
	container.conditions = conditions
	container.ingredients = ingredients
	container:SetAnchor(BOTTOMLEFT, IsJustaWritHelper_CraftPanelDivider, nil, 0, 0)
	return container
end
local function ResetEntry(entry)
	entry:SetHidden(true)
	entry:ClearAnchors()
	entry.conditions:SetText("")
	entry.ingredients:SetText("")
end
IJAWH.writEntry = ZO_ObjectPool:New(EntryFactory, ResetEntry)

function IJAWH:UpdateSolvent()
	local solvent
	if IJAWH_CurrentWrit.solvent then
		solvent = IJAWH_CurrentWrit.solvent
	elseif IJAWH_CurrentSolvent then
		solvent = IJAWH_CurrentSolvent
	end
	
	if solvent then
		if solvent.meetsUsageRequirement then IJAWH:TryAddItemToCraft(solvent) end
		IJAWH:RefreshKeybinds()
	end
end

local function isItemInBank()
	local craftingType = GetCraftingInteractionType()
	if IJAWH_WITHDRAW_ITEMS > 0 then
		local itemLinkName = GetItemLinkName(getCraftedItemLink())
		if not IsSmithingCraftingType(craftingType) then
			if IJAWH.withdrawItems[itemLinkName] then
				return true
			end
		else
			return false
		end
	end
	return false
end

-------------------------------------
-- Writ Data Functions
-------------------------------------
local function isWritForStation()
	local station = GetCraftingInteractionType()
	if IJAWH_CurrentWrit and IJAWH_CurrentWrit.qName ~= GetString(SI_IJAWH_EASYALCHEMY) then
		if IJAWH_CurrentWrit.recipeData then
			if IJAWH_CurrentWrit.writType == station and #IJAWH_CurrentWrit.recipeData >= 1 then
				return true
			end
		end
	end
	return false
end
local function getAlchemyMode()
	if isWritForStation() then
		return 1
	elseif IJAWH.savedVariables.easyAlchemy then
		return 2
	else
	return false
	end
end

local function getWritTypeByInteraction(index, qName)
    for k,v in pairs(IJAWH_WRIT_TYPES_BY_INDEX) do
		if IJAWH:Contains(qName,v) and k == index then
			return k
		end
    end
end
local function isWritAdded(qName)
	for i=1, #IJAWH.writData do
		if IJAWH.writData[i].qName == qName then
			return true
		end
    end
    return false
end
local function addWrit(writType, qName)
--	if not isWritAdded(qName) then
		IJAWH.writData[#IJAWH.writData +1] = {writType = writType, qName = qName, recipeData = {nil}, ingredients = {nil}}
--	end
end
local function setWritIndexFromQuestName(qName)
	for i=1, #IJAWH.writData do
		if IJAWH.writData[i].qName == qName then
			IJAWH_WD_INDEX = i
			return
		end
    end
    return false
end
local function getWritForStation()
	local station = GetCraftingInteractionType()
	for i=1, #IJAWH.writData do
		if IJAWH.writData[i].writType == station and not IJAWH.writData[i].completed then
			return ZO_ShallowTableCopy(IJAWH.writData[i])
		end
    end
    return false
end
local function getIngredientData(step)
	if IJAWH.writData[IJAWH_WD_INDEX] and IJAWH.writData[IJAWH_WD_INDEX].ingredients[step] then
		local ingredentsTemp = IJAWH.writData[IJAWH_WD_INDEX].ingredients[step]
		return ingredentsTemp.func(ingredentsTemp)
	else
		return false
	end
end
local function getQuestIndex(writName)
	for qIndex=1, MAX_JOURNAL_QUESTS do
		if IsValidQuestIndex(qIndex) then
			if GetJournalQuestType(qIndex) == QUEST_TYPE_CRAFTING then
				local qName,_,qDesc,_,_,qCompleted  = GetJournalQuestInfo(qIndex)
				if string.match(writName, qName) then
					return qIndex
				end
			end
		end
	end
	return -1
end	

-------------------------------------
-- Crafting Functions
-------------------------------------
local function setResultTooltip()
	if IJAWH_CurrentWrit.recipeData then
		local recipeData = IJAWH_CurrentWrit.recipeData[#IJAWH_CurrentWrit.recipeData]
		local craftingInteractionType = GetCraftingInteractionType()
		
		if craftingInteractionType == CRAFTING_TYPE_PROVISIONING then
			IJAWH:SetProvisioningResultTooltip(recipeData)
		elseif IsSmithingCraftingType(craftingInteractionType) then
			IJAWH:SetSmithingResultTooltip(recipeData)
		end
	end
end

local function onCraftStarted()
	if SCENE_MANAGER:IsShowing("gamepad_enchanting_creation") then
		GAMEPAD_CRAFTING_RESULTS:OnAllEnchantSoundsFinished()	-- speeds up a little by skipping final animation
	elseif SCENE_MANAGER:IsShowing("enchanting") then
		CRAFTING_RESULTS:OnAllEnchantSoundsFinished()	-- speeds up a little by skipping final animation
	end
    CALLBACK_MANAGER:UnregisterCallback("CraftingAnimationsStarted", onCraftStarted)
end
function IJAWH:GetAllCraftingParametersWithoutIteration(recipeData)
	if recipeData then
		local craftingInteractionType = GetCraftingInteractionType()
		if craftingInteractionType == CRAFTING_TYPE_PROVISIONING then
			return recipeData.recipeListIndex, recipeData.recipeIndex
		elseif IsSmithingCraftingType(craftingInteractionType) then
			return recipeData.patternIndex,
				recipeData.materialIndex,
				recipeData.materialQuantity,
				IJAWH.savedVariables.useMostStyle and recipeData.styleIndex or self.selectedStyle.itemstyleIndex or GetFirstKnownStyleIndex(),
				recipeData.traitIndex
		end
	end
end
function IJAWH:GetAllCraftingParameters(recipeData)
	if recipeData then
		local craftingInteractionType = GetCraftingInteractionType()
		if craftingInteractionType == CRAFTING_TYPE_PROVISIONING then
			local numItereations = updateIterations(recipeData)
			if numItereations == 0 then return end
			return recipeData.recipeListIndex, recipeData.recipeIndex, numItereations
		elseif IsSmithingCraftingType(craftingInteractionType) then
			return recipeData.patternIndex,
				recipeData.materialIndex,
				recipeData.materialQuantity,
				IJAWH.savedVariables.useMostStyle and recipeData.styleIndex or self.selectedStyle.itemstyleIndex or GetFirstKnownStyleIndex(),
				recipeData.traitIndex,
				false,
				recipeData.numIterations
		end
	end
end	

local function checkInventoryForSpace(recipeData)
	if IsSmithingCraftingType(GetCraftingInteractionType()) then
		if not CheckInventorySpaceSilently(recipeData.numIterations) then
			return false
		end
	else
--		local _,remainingInBank = GetItemLinkStacks(recipeData.itemLink)
--		local stackCount
--		if not recipeData.hasOther and FindFirstEmptySlotInBag(BAG_BACKPACK) == nil or FindFirstEmptySlotInBag(BAG_BACKPACK) == nil and (stackCount + recipeData.maximum) > 200 then
		if FindFirstEmptySlotInBag(BAG_BACKPACK) == nil then
			return false
		end
	end
	return true
end
		
local function craftWrit()
	local recipeData = IJAWH_CurrentWrit.recipeData[#IJAWH_CurrentWrit.recipeData]
	if recipeData and canCraft() then
		local craftingInteractionType = GetCraftingInteractionType()
		if not checkInventoryForSpace(recipeData) then
				ZO_Alert(UI_ALERT_CATEGORY_ERROR, SOUNDS.NEGATIVE_CLICK, SI_INVENTORY_ERROR_INVENTORY_FULL)
			return
		else
			CALLBACK_MANAGER:RegisterCallback("CraftingAnimationsStopped", onCraftItemUpdate)
--			EVENT_MANAGER:RegisterForEvent("IJAWH_OnCraftCompleted", EVENT_CRAFT_COMPLETED, onCraftItemUpdate)
			if craftingInteractionType == CRAFTING_TYPE_PROVISIONING then
				CraftProvisionerItem(IJAWH:GetAllCraftingParameters(recipeData))
				
			elseif IsSmithingCraftingType(craftingInteractionType) then
				IJAWH:SetSmithingStyleList()
				
				recipeData.styleIndex = IJAWH:UpdateSmithingStyleIndex(recipeData.numIterations, recipeData.patternIndex, 1)
				
				if recipeData.styleIndex == 0 then 
					CALLBACK_MANAGER:UnregisterCallback("CraftingAnimationsStopped", onCraftItemUpdate)
--					EVENT_MANAGER:UnregisterForEvent("IJAWH_OnCraftCompleted", EVENT_CRAFT_COMPLETED)
					return
				end
				CraftSmithingItem(IJAWH:GetAllCraftingParameters(recipeData))
				
			elseif craftingInteractionType == CRAFTING_TYPE_ALCHEMY then
				local numItereations = updateIterations(recipeData)
				if numItereations == 0 then return end
				if  IsInGamepadPreferredMode() then
					GAMEPAD_ALCHEMY:Create(numItereations)
				else
					ALCHEMY:Create(numItereations)
				end
			elseif craftingInteractionType == CRAFTING_TYPE_ENCHANTING then
				CALLBACK_MANAGER:RegisterCallback("CraftingAnimationsStarted", onCraftStarted)
				IJAWH:addRunesToCraft(recipeData.runeData)
				if  IsInGamepadPreferredMode() then
					GAMEPAD_ENCHANTING:Create(recipeData.numIterations)
				else
					ENCHANTING:Create(recipeData.numIterations)
				end
			end

		end
	else
		ZO_Alert(UI_ALERT_CATEGORY_ERROR, SOUNDS.NEGATIVE_CLICK, GetString(SI_TRADESKILLRESULT132))
	end
end

local function startAutoCraft()
	if IJAWH.PreviousKeybind.oldName then
		zo_callLater(craftWrit, 100)
	end
end

local function craftButtonEnabeled()
	return canCraft()
end
local function changeCraftKeybind()
	if not IJAWH.savedVariables.showCraftForWrit then return end
	if not IJAWH_CurrentWrit.recipeData then return end
	
	if not IJAWH.PreviousKeybind.oldName and IJAWH.savedVariables.tutorials.IJAWH_TUTORIAL_CRAFT_FOR_WRIT then
		local button = KEYBIND_STRIP.keybinds["UI_SHORTCUT_SECONDARY"]
		if button then
			IJAWH.craftKeybindButtonDescriptor = button.keybindButtonDescriptor
			
			IJAWH.PreviousKeybind.oldName = IJAWH.craftKeybindButtonDescriptor.name
			IJAWH.PreviousKeybind.oldCallback = IJAWH.craftKeybindButtonDescriptor.callback
			IJAWH.PreviousKeybind.oldEnabled = IJAWH.craftKeybindButtonDescriptor.enabled
			IJAWH.craftKeybindButtonDescriptor.name = GetString(SI_IJAWH_CRAFT_WRIT)
			IJAWH.craftKeybindButtonDescriptor.callback = craftWrit
			IJAWH.craftKeybindButtonDescriptor.enabled = craftButtonEnabeled
			
			KEYBIND_STRIP:UpdateKeybindButton(IJAWH.craftKeybindButtonDescriptor)

			if doAutoCraft and not isItemInBank() then 
				doAutoCraft = false
				startAutoCraft()
			end
			return
		end
	end
	if not IJAWH.savedVariables.tutorials.IJAWH_TUTORIAL_CRAFT_FOR_WRIT then
		IJAWH:DialogueQueue("IJAWH_TUTORIAL_CRAFT_FOR_WRIT")
	end
	
	zo_callLater(changeCraftKeybind , 1000)
end
local function restoreCraftKeybind()
	doAutoCraft = false
	
	if IJAWH.PreviousKeybind.oldName then
		IJAWH.craftKeybindButtonDescriptor.name = IJAWH.PreviousKeybind.oldName
		IJAWH.craftKeybindButtonDescriptor.callback = IJAWH.PreviousKeybind.oldCallback
		IJAWH.craftKeybindButtonDescriptor.enabled = IJAWH.PreviousKeybind.oldEnabled
		KEYBIND_STRIP:UpdateKeybindButton(IJAWH.craftKeybindButtonDescriptor)
		IJAWH.PreviousKeybind = {}
		IJAWH.craftKeybindButtonDescriptor = {}
	end
end

-------------------------------------
-- Callbacks and Hooks
-------------------------------------
local function isHookEnabled()
	return (isWritForStation() and 
		IJAWH.savedVariables.showCraftForWrit and
		canCraft() and
		not ZO_CraftingUtils_IsPerformingCraftProcess())
end

local IJAWH_SMITHING_oldMode, IJAWH_ENCHANTING_oldMode
do -- hooks
	ZO_PostHook(PROVISIONER, "OnTabFilterChanged", function(self, filterData)
		if isHookEnabled() then 
			if self.filterType ~= PROVISIONER_SPECIAL_INGREDIENT_TYPE_FURNISHING then
				if IJAWH.savedVariables.autoCraft then doAutoCraft = true end
				changeCraftKeybind()
			else
				restoreCraftKeybind()
			end
		end
	end)
	ZO_PostHook(GAMEPAD_PROVISIONER, "OnTabFilterChanged", function(self, filterType)
		if isHookEnabled() then 
			if filterType ~= PROVISIONER_SPECIAL_INGREDIENT_TYPE_FURNISHING then
				if IJAWH.savedVariables.autoCraft then doAutoCraft = true end
				changeCraftKeybind()
			else
				restoreCraftKeybind()
			end
		end
	end)
	
	ZO_PostHook(SMITHING_GAMEPAD.creationPanel, "OnStyleChanged", function(self, selectedData)
		if isHookEnabled() then
			IJAWH.selectedStyle = {localizedName = selectedData.localizedName, itemstyleIndex = selectedData.itemStyleId}
		end
	end)
	ZO_PostHook(SMITHING.creationPanel, "OnStyleChanged", function(self, selectedData)
		if isHookEnabled() then
			IJAWH.selectedStyle = {localizedName = selectedData.localizedName, itemstyleIndex = selectedData.itemStyleId}
		end
	end)
	
	ZO_PostHook(SMITHING, "SetMode", function(self)
		if isHookEnabled() then
			if self.mode ~= IJAWH_SMITHING_oldMode and self.mode ~= SMITHING_MODE_RECIPES then
				if self.mode == SMITHING_MODE_CREATION then
					changeCraftKeybind()
					
				else
					restoreCraftKeybind()
				end
				IJAWH_SMITHING_oldMode = self.mode
			end
			
		end
	end)
	
	ZO_PostHook(ENCHANTING.inventory, "ChangeMode", function(self, enchantingMode)
		if isHookEnabled() then
			if enchantingMode ~= IJAWH_ENCHANTING_oldMode then
				if enchantingMode == ENCHANTING_MODE_CREATION then
					changeCraftKeybind()
				else
					restoreCraftKeybind()
				end
				IJAWH_ENCHANTING_oldMode = enchantingMode
			end
		end
	end)
			
	local function startCraftProcess(owner)
		ZO_PreHook(owner, "StartCraftProcess", function(self, playStopTooltipAnimation)
			if not IJAWH.PreviousKeybind.oldName then return false end
			
			self.tooltipAnimationCompleted = false
			self.craftingProcessCompleted = false
			
			self.playStopTooltipAnimation = playStopTooltipAnimation
			self.playStartTooltipAnimation = not playStopTooltipAnimation


			self.craftingProcessProducesItems = true
				  
			CALLBACK_MANAGER:FireCallbacks("CraftingAnimationsStarted")
			if self.playStartTooltipAnimation then
				self:PlayTooltipAnimation()
			end
			
			return true
		end)
	end
	
	startCraftProcess(GAMEPAD_CRAFTING_RESULTS)
	startCraftProcess(CRAFTING_RESULTS)
end

local function setUpCallbacks()
	local function smithingStateChange(oldState, newState)
		if SMITHING_GAMEPAD.mode == SMITHING_MODE_RECIPES then return end
		local craftingType = GetCraftingInteractionType()
		
		if IsInGamepadPreferredMode() then
			local isCraftingTypeDifferent = craftingType ~= SMITHING_GAMEPAD.oldCraftingType and true
			SMITHING_GAMEPAD.creationPanel:SetCraftingType(craftingType, SMITHING_GAMEPAD.oldCraftingType, isCraftingTypeDifferent)
		else
			local isCraftingTypeDifferent = not SMITHING.interactingWithSameStation
			SMITHING.creationPanel:SetCraftingType(craftingType, SMITHING.oldCraftingType, isCraftingTypeDifferent)
		end
		
		if isWritForStation() then
			if newState == SCENE_SHOWN then
				if IJAWH.savedVariables.autoCraft and IJAWH.savedVariables.useMostStyle then
					if not IsInGamepadPreferredMode() then
							ZO_MenuBar_SelectDescriptor(SMITHING.modeBar, SMITHING_MODE_CREATION)
						end
					doAutoCraft = true
				end
				if IsInGamepadPreferredMode() then
					changeCraftKeybind()
				end
			elseif newState == SCENE_HIDDEN then
				restoreCraftKeybind()
			end
		end
	end
	SMITHING_SCENE:RegisterCallback("StateChange", smithingStateChange)
	GAMEPAD_SMITHING_CREATION_SCENE:RegisterCallback("StateChange", smithingStateChange)
	
	local function alchemyStateChange(oldState, newState)
		local alchemyMode = getAlchemyMode()
		if alchemyMode then
			if newState == SCENE_SHOWN then
				if alchemyMode == 1 then
					if IJAWH.savedVariables.autoCraft then 
						if not IsInGamepadPreferredMode() then
							ZO_MenuBar_SelectDescriptor(ALCHEMY.modeBar, ZO_ALCHEMY_MODE_CREATION)
						end
						if IJAWH.savedVariables.autoAlchemy then doAutoCraft = true end
					end
					changeCraftKeybind()
					IJAWH:EnableReagentPanel(true)
					IJAWH:showCraftPannel()
				elseif alchemyMode == 2 then
					
					IJAWH.craftPanel.icon:SetTexture(IJAWH.iconList[GetCraftingInteractionType()])
					IJAWH.craftPanel.header:SetText(GetString(SI_IJAWH_EASYALCHEMY))
					IJAWH.craftTLW:SetHidden(false)
					IsJustaEasyAlchemy.isEasyAlchemy = true
					ZO_MenuBar_UpdateButtons(ALCHEMY.modeBar)
					if ALCHEMY.mode == 3 then
						ALCHEMY.mode = nil
						ALCHEMY:SetMode(3)
					else
						IJAEA_SavedAlchemy:AddKeybindButton()
						IsJustaEasyAlchemy:OnAlchemyStation()
					end
				else
					return
				end
				IJAWH:UpdateSolvent()
				IJAWH:RefreshKeybinds()
			elseif newState == SCENE_HIDING then
				IJAWH:EnableReagentPanel(false)
				if alchemyMode == 1 then IJAWH:showCraftPannel() end
			elseif newState == SCENE_HIDDEN then
				restoreCraftKeybind()
				IJAEA_KeyboardSavedAlchemyTopLevel:SetHidden(true)
				if IJAWH.savedVariables.easyAlchemy then 
					IJAEA_SavedAlchemy:RemoveKeybindButton()
					IsJustaEasyAlchemy.AlchemyTLW:SetHidden(true) 
				end
			end
		end
	end
	GAMEPAD_ALCHEMY_CREATION_SCENE:RegisterCallback("StateChange", alchemyStateChange)
	ALCHEMY_SCENE:RegisterCallback("StateChange", alchemyStateChange)

	local function enchantingStateChange(oldState, newState)
		if not isWritForStation() then return end
        if newState == SCENE_SHOWING then
			IJAWH:addRunesToCraft(IJAWH_CurrentWrit.recipeData[#IJAWH_CurrentWrit.recipeData].runeData)
		elseif newState == SCENE_SHOWN then
			if IJAWH.savedVariables.autoCraft then 
				if not IsInGamepadPreferredMode() then
					ZO_MenuBar_SelectDescriptor(ENCHANTING.modeBar, ENCHANTING_MODE_CREATION)
				end
				doAutoCraft = true
			end
			changeCraftKeybind()
        elseif newState == SCENE_HIDDEN then
			restoreCraftKeybind()
        end
    end
    GAMEPAD_ENCHANTING_CREATION_SCENE:RegisterCallback("StateChange", enchantingStateChange)
    ENCHANTING_SCENE:RegisterCallback("StateChange", enchantingStateChange)
	
	local function prvisionerStateChange(oldState, newState)
		if not isWritForStation() then return end
        if newState == SCENE_SHOWN and SMITHING_GAMEPAD.mode ~= SMITHING_MODE_RECIPES then
			if IJAWH.savedVariables.autoCraft then doAutoCraft = true end
			changeCraftKeybind()
        elseif newState == SCENE_HIDDEN then
			restoreCraftKeybind()
        end
    end
    GAMEPAD_PROVISIONER_ROOT_SCENE:RegisterCallback("StateChange", prvisionerStateChange)
	PROVISIONER_SCENE:RegisterCallback("StateChange", prvisionerStateChange)	
end
local function getCurrentstep(patternIndex)
	for k,v in pairs(IJAWH_CurrentWrit.recipeData) do
		if v.patternIndex == patternIndex then
			return k
		end
	end
end
local function GetMissingMessage(conditionInfo, currentCount, maxCount)
    --If we have already met the condition requirements, we no longer care about what components we have
    if currentCount < maxCount then
        if conditionInfo.craftingType == CRAFTING_TYPE_ENCHANTING then
            local potencyRune, essenceRune, aspectRune = GetRunesForItemIdIfKnown(conditionInfo.itemId, conditionInfo.materialItemId, conditionInfo.itemFunctionalQuality)
            --GetRunesForItemIdIfKnown will return nil for all values if any of the runes are unknown
            --Therefore, checking any of them for nil would be sufficient, it doesn't have to be potency
            if potencyRune == nil then
                return GetString(SI_ENCHANTING_UNKNOWN_RUNES), GetString(SI_CRAFT_ADVISOR_UNKNOWN_RUNES_TOOLTIP)
            elseif not DoesPlayerHaveRunesForEnchanting(aspectRune, essenceRune, potencyRune) then
                return GetString(SI_CRAFTING_MISSING_ITEMS), GetString(SI_CRAFT_ADVISOR_ENCHANTING_MISSING_ITEMS_TOOLTIP)
            end
        elseif conditionInfo.craftingType == CRAFTING_TYPE_PROVISIONING then
            local recipeLists = PROVISIONER_MANAGER:GetRecipeListData(conditionInfo.craftingType)
            --Look for a matching recipe
            for listIndex, recipeList in pairs(recipeLists) do
                for _, recipe in ipairs(recipeList.recipes) do
                    --If we have a match, then we're done, return early
                    if recipe.resultItemId == conditionInfo.itemId then
                        return
                    end
                end
            end
            --If we get here, that means we are missing the recipe
            return GetString(SI_PROVISIONER_MISSING_RECIPE), GetString(SI_CRAFT_ADVISOR_PROVISIONING_MISSING_RECIPE_TOOLTIP)
        elseif conditionInfo.craftingType == CRAFTING_TYPE_ALCHEMY then
            local validCombinationFound = false
            local needsThirdSlot = conditionInfo.isMasterWrit and GetNonCombatBonus(NON_COMBAT_BONUS_ALCHEMY_THIRD_SLOT) == 0
            --Check and see if the alchemy logic has found any valid combinations
            if IsInGamepadPreferredMode() then   
                validCombinationFound = GAMEPAD_ALCHEMY:HasValidCombinationForQuest()
            else
                validCombinationFound = ALCHEMY:HasValidCombinationForQuest()
            end
            if needsThirdSlot then
                return GetString(SI_ALCHEMY_REQUIRES_THIRD_SLOT), GetString(SI_CRAFT_ADVISOR_ALCHEMY_REQUIRES_THIRD_SLOT_TOOLTIP)
            elseif not validCombinationFound then
                return GetString(SI_ALCHEMY_MISSING_OR_UNKNOWN), GetString(SI_CRAFT_ADVISOR_ALCHEMY_MISSING_OR_UNKNOWN_TOOLTIP)
            end
		elseif IsSmithingCraftingType(conditionInfo.craftingType) then
			-- ZOS did not add a method for missing smithing items
			local recipeData = IJAWH_CurrentWrit.recipeData
				
			local totalMaterial, totalItems, styleIndex = 0, 0, 0
			
			local missingMessage, missingDescription = '', ''
			local patternIndex, materialIndex = GetSmithingPatternInfoForItemId(conditionInfo.itemId, conditionInfo.materialItemId, conditionInfo.craftingType)
			local step = getCurrentstep(patternIndex)
			for i=1, conditionInfo.conditionIndex - 1 do
				-- build material quantity that will be used by all items to be crafted
				if recipeData[i] then
					totalMaterial = totalMaterial + recipeData[i].materialQuantity * recipeData[i].numIterations
					
					totalItems = totalItems + recipeData[i].numIterations
				end
			end
			if totalMaterial > GetCurrentSmithingMaterialItemCount(recipeData[step].patternIndex, recipeData[step].materialIndex) then
				missingMessage = "     " .. GetString(SI_TRADESKILLRESULT141)
			end
			styleIndex = IJAWH:UpdateSmithingStyleIndex(recipeData[step].numIterations, recipeData[step].patternIndex, totalItems)
			if styleIndex == 0 then 
				if missingMessage == '' then
					missingMessage = "     " .. GetString(SI_TRADESKILLRESULT142)
				else
					missingMessage = missingMessage .. "\n"  .. "     " .. GetString(SI_TRADESKILLRESULT142)
				end
			end
			if recipeData[step].traitIndex > 1 and totalItems > GetCurrentSmithingTraitItemCount(recipeData[step].traitIndex) then
				if missingMessage == '' then
					missingMessage = "     " .. GetString(SI_TRADESKILLRESULT143)
				else
					missingMessage = missingMessage .. "\n"  .. "     " .. GetString(SI_TRADESKILLRESULT143)
				end
			end
			return missingMessage, GetString(SI_IJAWH_CRAFT_ADVISOR_SMITHING_MISSING_TOOLTIP)
			--	GetString(SI_TRADESKILLRESULT141), GetString(SI_IJAWH_CRAFT_ADVISOR_SMITHING_MISSING_MATERIAL_TOOLTIP)
        end
    end
end

ZO_PreHook(ZO_WRIT_ADVISOR_GAMEPAD, "RebuildConditions", function(self, questInfo)
	zo_callLater(function()
		self.questConditionControlPool:ReleaseAllObjects()
		if questInfo then
			local _, _, _, _, conditionCount = GetJournalQuestStepInfo(questInfo.questIndex, QUEST_MAIN_STEP_INDEX)
			local previousControl = nil
			local conditionInfoIndex = 1
			--Add the conditions
			for conditionIndex = 1, conditionCount do
				local conditionText, curCount, maxCount, isFailCondition, isComplete, _, isVisible, conditionType = GetJournalQuestConditionInfo(questInfo.questIndex, QUEST_MAIN_STEP_INDEX, conditionIndex)
				if (not isFailCondition) and (conditionText ~= "") and not isComplete and isVisible then
					if curCount == maxCount then
						conditionText = zo_strformat("|c<<1>><<2>>|r","00cc00",conditionText)
					else
--						conditionText = 
					end
					local control = self.questConditionControlPool:AcquireObject()
					control:ClearAnchors()
					control:SetText(conditionText)
					control:SetColor(GetInterfaceColor(INTERFACE_COLOR_TYPE_TEXT_COLORS, INTERFACE_TEXT_COLOR_SELECTED))
					
					--Determine if we need to anchor to the header or to a previous condition
					if previousControl ~= nil then
						control:SetAnchor(TOPRIGHT, previousControl, BOTTOMRIGHT, 0, 16)
					else
						control:SetAnchor(TOPRIGHT, self.questHeader, BOTTOMRIGHT, 0, 16)
					end
					previousControl = control
					--Check if we need to add an error message underneath this condition
					if questInfo.conditionData[conditionInfoIndex] and questInfo.conditionData[conditionInfoIndex].conditionIndex == conditionIndex then
						local missingMessage = GetMissingMessage(questInfo.conditionData[conditionInfoIndex], curCount, maxCount)
						if missingMessage then
							local missingControl = self.questConditionControlPool:AcquireObject()
							missingControl:ClearAnchors()
							missingControl:SetText(missingMessage)
							missingControl:SetColor(ZO_ERROR_COLOR:UnpackRGBA())
							missingControl:SetAnchor(TOPRIGHT, previousControl, BOTTOMRIGHT)
							previousControl = missingControl
						end
						conditionInfoIndex = conditionInfoIndex + 1
					end
				end
			end      
		end
	end, 50)
end)
ZO_PreHook(ZO_WRIT_ADVISOR_WINDOW, "RefreshQuestList", function(self)
	zo_callLater(function()
		if WRIT_ADVISOR_FRAGMENT:IsShowing() and not ZO_CraftingUtils_IsPerformingCraftProcess() then
			local quests = self.questMasterList
			self.questIndexToTreeNode = {}
			-- Add items to the tree
			self.navigationTree:Reset()
			local questNodes = {}
			local firstNode = nil
			local previousNode = nil 
			local assistedNode = nil
			for i, questInfo in ipairs(quests) do
				--First, add the quest name
				questNodes[questInfo] = self.navigationTree:AddNode("ZO_ActiveWritHeader", questInfo)
				self.questIndexToTreeNode[questInfo.questIndex] = questNodes[questInfo]
				local _, _, _, _, conditionCount = GetJournalQuestStepInfo(questInfo.questIndex, QUEST_MAIN_STEP_INDEX)
				local conditionInfoIndex = 1;
				--Add the conditions for the quest
				for conditionIndex = 1, conditionCount do
					local conditionText, curCount, maxCount, isFailCondition, isComplete, _, isVisible, conditionType = GetJournalQuestConditionInfo(questInfo.questIndex, QUEST_MAIN_STEP_INDEX, conditionIndex)
					if (not isFailCondition) and (conditionText ~= "") and not isComplete and isVisible then
						if curCount == maxCount then
							conditionText = zo_strformat("|c<<1>><<2>>|r","00cc00",conditionText)
						else
	--						conditionText = 
						end
						local taskNode = self.navigationTree:AddNode("ZO_ActiveWritNavigationEntry", {name = conditionText}, questNodes[questInfo])
						firstNode = firstNode or taskNode
						if previousNode then
							previousNode.nextNode = taskNode
						end
						if i == #quests and conditionIndex == conditionCount then
							taskNode.nextNode = firstNode
						end
						--Select the first quest in the list that has incomplete crafting tasks
						if assistedNode == nil and curCount < maxCount then
							assistedNode = questNode
						end
						previousNode = taskNode
						--There are certain cases where we want to defer adding the missing text, so don't do it here in that case
						if not CRAFT_ADVISOR_MANAGER:ShouldDeferRefresh() then
							--Determine if we need to add an error message after this condition
							if questInfo.conditionData[conditionInfoIndex] and questInfo.conditionData[conditionInfoIndex].conditionIndex == conditionIndex then
								local missingMessage, missingDescription = GetMissingMessage(questInfo.conditionData[conditionInfoIndex], curCount, maxCount)
								if missingMessage then
									local missingNode = self.navigationTree:AddNode("ZO_ActiveWritNavigationEntry", {errorHeader = missingMessage, errorText = missingDescription, missing = true}, questNodes[questInfo])
									previousNode.nextNode = missingNode
									if i == #quests and conditionIndex == conditionCount then
										missingNode.nextNode = firstNode
									end
									previousNode = missingNode
								end
								conditionInfoIndex = conditionInfoIndex + 1
							end
					   end
					end
				end
			end
			self.navigationTree:Commit(assistedNode)
			self.dirtyFlag = false
		else
			self.dirtyFlag = true
		end
	end, 50)
	return true
end)
-------------------------------------
-- Writ panel
-------------------------------------
local WRIT_SORT_KEYS ={
	completed = { tiebreaker = "inBank", reverseTiebreakerSortOrder = ZO_SORT_ORDER_UP },
	inBank = { tiebreaker = "qName", tieBreakerSortOrder = ZO_SORT_ORDER_UP },
	qName = { },
	itemLink = { },
	canCraft = {tiebreaker = "itemLink" },
}
local function writSortFunc(data1, data2)
	return ZO_TableOrderingFunction(data1, data2, "completed", WRIT_SORT_KEYS, ZO_SORT_ORDER_UP) 
end
function IJAWH:SetHeaderColor(control, action)
	local r, g, b, a = control:GetColor()
	local enter = {r = r and r / 0.8 or 0, g = g and g / 0.8 or 0, b = b and b / 0.8 or 0}
	local down = {r = r and r * 0.8 or 0, g = g and g * 0.8 or 0, b = b and b * 0.8 or 0}
	
	control:SetColor(enter.r, enter.g, enter.b, 1)
	
	control:SetHandler("OnMouseExit", function()
		control:SetColor(r, g, b, 1)
	end)
	control:SetHandler("OnMouseDown", function()
		control:SetColor(down.r, down.g, down.b, 1)
	end)
end
local function updateWritsPanel()
	IJAWH.writsPanel.writList:ReleaseAllObjects()

	local function getWritDetails(qName)
		local function isBanked(qName)
		if not IJAWH.withdrawItems then return end
			for k,v in pairs(IJAWH.withdrawItems) do
				if string.match(v.qName, qName) then
					return true
				end
			end
		end
		
		local function getWritStatus(qIndex, index)
			local tot, comp, conText = 0, 0, ''
			for lineId = 1, GetJournalQuestNumConditions(qIndex,1) do
				local condition,current,maximum,_,complete = GetJournalQuestConditionInfo(qIndex,1,lineId)
				if condition ~= '' then
					if string.find(condition, GetString(SI_IJAWH_DELIVER)) then
						conText = condition
						IJAWH_WRITLIST[index].completed = true
					else
						tot = tot +1
						--- get number of conditions
						if current == maximum then
							comp = comp + 1 -- num of completed conditions
						end
						conText = conText .. condition .. "\n"
					end
				end
			end
			conText = string.gsub(conText, "\n$", "")
			IJAWH_WRITLIST[index].toolTip = conText
			IJAWH_WRITLIST[index].status = comp .. "/" .. tot
			if isBanked(IJAWH_WRITLIST[index].qName) then IJAWH_WRITLIST[index].inBank = true end
		end
		
		for i=1, #IJAWH_WRITLIST do
			local qIndex = getQuestIndex(IJAWH_WRITLIST[i].qName)
			local qName,_,qDesc,_,_,qCompleted, _, _, _, questType,  _  = GetJournalQuestInfo(qIndex)
			getWritStatus(qIndex, i)
		end	
	end
	
	--	called before in order to sort the writs
	getWritDetails(qName)
	table.sort(IJAWH_WRITLIST, writSortFunc)
	
	local completed, yPos = 0, 0
	for i=1, #IJAWH_WRITLIST do
		local writEntry = IJAWH.writsPanel.writList:AcquireObject(i)

		local writColor
		local qName = IJAWH_WRITLIST[i].qName
		
		if IJAWH_WRITLIST[i].completed then
			completed = completed + 1
			writColor = "00cc00"
		else
			writColor = "CCCCCC"
			writEntry.status:SetText(zo_strformat("|c<<1>><<2>>|r",writColor,IJAWH_WRITLIST[i].status))
		end
		yPos = 28 * i

		writEntry.writ:SetText(zo_strformat(GetString(SI_IJAWH_WRIT_NAME), writColor, qName))
		writEntry.writ:SetAnchor(CENTER, IsJustaWritHelper_WritsPanelContainerDivider, nil, 0, yPos)
		writEntry.toolTip:SetAnchor(CENTER, IsJustaWritHelper_WritsPanelContainerDivider, nil, 0, yPos)
		
		writEntry.status:SetAnchor(RIGHT, IsJustaWritHelper_WritsPanelContainerDivider, RIGHT, 0, yPos)

		local writType = IJAWH_WRITLIST[i].currentWritType
--[[		
		if writType == -1 then 
			writType = IJAWH_WRIT_TYPES_BY_NAME[qName]
			IJAWH_WRITLIST[i].currentWritType = writType
		end
--]]
		writEntry.setToolTip(IJAWH_WRITLIST[i].toolTip)
		
		local texture = ''
		if IJAWH_WRITLIST[i].inBank then
			texture = "/esoui/art/tooltips/icon_bank.dds"
			writEntry.iconToolTip:SetHidden(false)
			writEntry.iconToolTip:SetAnchor(LEFT, IsJustaWritHelper_WritsPanelContainerDivider, nil, 0, yPos)
			writEntry.icon:SetDimensions(30,30)
			writEntry.icon:SetAnchor(LEFT, IsJustaWritHelper_WritsPanelContainerDivider, nil, 5, yPos)
		else
			texture = IJAWH.iconList[writType]
			writEntry.icon:SetDimensions(40,40)
			writEntry.icon:SetAnchor(LEFT, IsJustaWritHelper_WritsPanelContainerDivider, nil, 0, yPos)
		end
		
		if texture ~= '' then
			writEntry.icon:SetTexture(texture)
			writEntry.icon:SetHidden(false)
		else
			writEntry.icon:SetHidden(true)
			writEntry.iconToolTip:SetHidden(true)
		end
	end
	
	IJAWH_WRITPANEL_ADJUSTED_HEIGHT = yPos + 25
	
	local headerColor
	if completed == #IJAWH_WRITLIST then
		headerColor = "00FF00"
		IJAWH.writsPanel.header:SetColor(0, 0.8, 0, 1)
	else
		headerColor = "CCCCCC"
		IJAWH.writsPanel.header:SetColor(0.8, 0.8, 0.8, 1)
	end
	local totalWrits = #IJAWH_WRITLIST
	local header = zo_strformat(GetString(SI_IJAWH_TOTAL_WRITS), completed, totalWrits)
	
	IJAWH_WRITPANEL_ADJUSTED_HEIGHT = IJAWH_WRITPANEL_ADJUSTED_HEIGHT + IJAWH_WRITPANEL_ORIGINAL_HEIGHT
	
	local panelHeight
	if IJAWH_WRITPANEL_LIST_IsHidden then
		panelHeight = IJAWH_WRITPANEL_ORIGINAL_HEIGHT
	else
		IJAWH:wpMinMax(false)
		panelHeight = IJAWH_WRITPANEL_ADJUSTED_HEIGHT
	end
	IJAWH.writsPanel.header:SetText(header)
	IJAWH.writsPanel.container:SetHeight(panelHeight)

	if completed == #IJAWH_WRITLIST and #IJAWH_WRITLIST > 0 then
		-- minimize or hide list when all lists are completed
		local oldState = IJAWH_WRITPANEL_LIST_IsHidden and true or false
		IJAWH:wpMinMax(true)
		IJAWH_WRITPANEL_LIST_IsHidden = oldState
	elseif not IJAWH_WRITPANEL_LIST_IsHidden then
		IJAWH:wpMinMax(false)
	end
end

local function hideWritPanel()
	return #IJAWH_WRITLIST < 1
		or IsUnitInCombat("player")
		or IsUnitInDungeon("player")
		or IsUnitActivelyEngaged("player")
		or IsUnitPvPFlagged("player")
		or IJAWH.savedVariables.hideWhileMounted and IsMounted()
end

CALLBACK_MANAGER:RegisterCallback("IJAWH_Update_Writs_Panel", function() zo_callLater(updateWritsPanel, 800) end)
local function writsPanelControl()
	if IsUnitGrouped("player") then
		if not IJAWH.groupCheck then
			IJAWH.groupCheck = true
			IJAWH.writsPanelFunc:MoveRight()
		end
		local currentGroupSize = GetGroupSize()
		if currentGroupSize > 4 then
			IJAWH:wpMinMax(true)
		end
	else
		if IJAWH.groupCheck then
			IJAWH.groupCheck = false
			IJAWH.writsPanelFunc:MoveLeft()
		end
	end
	
	IsJustaWritHelper_WritsPanel:SetHidden(hideWritPanel())
--	zo_callLater(updateWritsPanel, 50)
	updateWritsPanel()
end


-------------------------------------
-- 
-------------------------------------
local function enchantRootState(oldState, newState)
	GAMEPAD_ENCHANTING_MODE_SCENE_ROOT:UnregisterCallback("StateChange", enchantRootState)
	if newState == SCENE_SHOWN then
--		GAMEPAD_ENCHANTING.modeList.mode = ENCHANTING_MODE_CREATION
--		GAMEPAD_ENCHANTING:SelectMode()
		SCENE_MANAGER:Push("gamepad_enchanting_creation")
	end
end
local function alcemyRootState(oldState, newState)
	GAMEPAD_ALCHEMY_ROOT_SCENE:UnregisterCallback("StateChange", alcemyRootState)
	if newState == SCENE_SHOWN then
--		GAMEPAD_ALCHEMY.modeList.mode = ZO_ALCHEMY_MODE_CREATION
--		GAMEPAD_ALCHEMY:SelectMode()
		SCENE_MANAGER:Push("gamepad_alchemy_creation")
	end
end
local function smithingRootState(oldState, newState)
	GAMEPAD_SMITHING_ROOT_SCENE:UnregisterCallback("StateChange", smithingRootState)
	if newState == SCENE_SHOWN then
		SMITHING_GAMEPAD:SetMode(SMITHING_MODE_CREATION)
	end
end

function IJAWH:setStationForWrit()
-------------------	PROVISIONING
	if IJAWH_CurrentWrit.writType == CRAFTING_TYPE_PROVISIONING then
		if IJAWH.savedVariables.showCraftForWrit then
			EVENT_MANAGER:RegisterForUpdate("IJAWH_setResultTooltip", 100, setResultTooltip)
		end
--	end
------------------- ALCHEMY
	elseif IJAWH_CurrentWrit.writType == CRAFTING_TYPE_ALCHEMY then
		IJAWH:AddKeybinds()
		if IJAWH_CurrentWrit.recipeData then
			IJAWH.recipeList:Clear()
			for i=1, #IJAWH_CurrentWrit.recipeData do
				IJAWH.recipeList:AddEntry(IJAWH_CurrentWrit.recipeData[i])
			end
			IJAWH.recipeList:Commit()
		end
		
		if not IJAWH.savedVariables.tutorials.IJAWH_TUTORIAL_ALCHEMYWRIT and GetCraftingInteractionType() == CRAFTING_TYPE_ALCHEMY then
			IJAWH:DialogueQueue("IJAWH_TUTORIAL_ALCHEMYWRIT")
		end
		if IJAWH.savedVariables.tutorials.IJAWH_TUTORIAL_ALCHEMYWRIT and IJAWH.savedVariables.autoCraft then
			if IsInGamepadPreferredMode() then
				GAMEPAD_ALCHEMY_ROOT_SCENE:RegisterCallback("StateChange", alcemyRootState)
			else
			end
		end
-------------------	ENCHANTING
	elseif IJAWH_CurrentWrit.writType == CRAFTING_TYPE_ENCHANTING then
		IJAWH:addRunesToCraft(IJAWH_CurrentWrit.recipeData[#IJAWH_CurrentWrit.recipeData].runeData)

		if IsInGamepadPreferredMode() and IJAWH.savedVariables.autoCraft then
			GAMEPAD_ENCHANTING_MODE_SCENE_ROOT:RegisterCallback("StateChange", enchantRootState)
		end
-------------------	SMITHING
	else
		IJAWH:SetSmithingStyleList()
		if IJAWH.savedVariables.showCraftForWrit then
			EVENT_MANAGER:RegisterForUpdate("IJAWH_setResultTooltip", 100, setResultTooltip)
		end
		if not IJAWH.savedVariables.tutorials.IJAWH_TUTORIAL_STYLEMATERIALS then
			IJAWH:DialogueQueue("IJAWH_TUTORIAL_STYLEMATERIALS")
		end
		if IJAWH.savedVariables.tutorials.IJAWH_TUTORIAL_STYLEMATERIALS and IJAWH.savedVariables.autoCraft then
			if IsInGamepadPreferredMode() then
				GAMEPAD_SMITHING_ROOT_SCENE:RegisterCallback("StateChange", smithingRootState)
			end
		end
	end
end

local function buildWritData(qIndex, qName, craftingInteractionType)
	local withdrawText = {}
	if craftingInteractionType == CRAFTING_TYPE_PROVISIONING then
		withdrawText = IJAWH:ParseProvisioningQuest(qName, qIndex, lineId)
	elseif craftingInteractionType == CRAFTING_TYPE_ALCHEMY then
		withdrawText = IJAWH:ParseAlchemyQuest(qName, qIndex, lineId)
	elseif craftingInteractionType == CRAFTING_TYPE_ENCHANTING then
		withdrawText = IJAWH:ParseEnchantingQuest(qName, qIndex, lineId)
	elseif IsSmithingCraftingType(craftingInteractionType) then
		IJAWH:ParseSmithingQuest(qName, qIndex, lineId)
	end
	if #withdrawText > 0 then
		IJAWH.writData[IJAWH_WD_INDEX].WithdrawText = withdrawText
	end
--	if #IJAWH.writData[IJAWH_WD_INDEX].recipeData < 1 then table.remove(IJAWH.writData, IJAWH_WD_INDEX) end
end

local function getWritsFromJournal()
--	GAMEPAD_ALCHEMY_CREATION_SCENE:UnregisterCallback("StateChange", onAlchemyStateChangedCallback)
	local isCraftingQuest = false
	local GetCraftingInteractionType = GetCraftingInteractionType()
	IJAWH_WRITLIST = {}
	for qIndex=1, MAX_JOURNAL_QUESTS do
		if IsValidQuestIndex(qIndex) then
			isCraftingQuest = true
			if GetJournalQuestType(qIndex) == QUEST_TYPE_CRAFTING then
				local qName,_,qDesc,_,_,qCompleted = GetJournalQuestInfo(qIndex)
			-- set writ entries for the Writ Panel
				local currentWritType, masterWrit, whitchWrit, isMaster = -1, 0, 0, false
				
				if qName ~= "" then
					if IJAWH_MASTER_WRITS[qName] then
						if string.match(qName, GetString(SI_IJAWH_WITCHES)) then
							whitchWrit = getWitchesType(qIndex)
						else
							masterWrit = IJAWH_MASTERWRIT_TYPES_BY_NAME[qName]
							isMaster = true
						end
					end
					
					currentWritType = whitchWrit > 0 and whitchWrit or IJAWH_CONSUMABEL_WRIT[qName] or getWritTypeByInteraction(GetCraftingInteractionType, qName) or -1
				-- build initial writ list
					if not isWritAdded(qName) then
						if currentWritType > 0 then
							addWrit(currentWritType, qName)
							setWritIndexFromQuestName(qName)
							buildWritData(qIndex, qName, currentWritType)
						end
					end
					
					currentWritType = isMaster and masterWrit or currentWritType > 0 and currentWritType or IJAWH_DAILYWRIT_TYPES_BY_NAME[qName]
					IJAWH_WRITLIST[#IJAWH_WRITLIST + 1] = {qName = qName, currentWritType = currentWritType, completed = false, inBank = false, toolTip = '', status = '', texture = ''}
				end
			end
		end
	end
	
	if isCraftingQuest then
		local elapsedTime = getTimeElapsed(IJAWH.LastChecked)
		if #IJAWH.withdrawItems > 0 and elapsedTime > 600 then
			if IJAWH.savedVariables.showWithdrawInChat then d(zo_strformat(SI_IJAWH_IN_WTHDRAW_LIST)) end
			IJAWH.LastChecked = elapsedTime
		end
	end
end

local function notEnoughCraftingMaterial(step, styleListIndex)
	local totals, recipeData = 0, IJAWH_CurrentWrit.recipeData
	if not recipeData[1] then
		return false
	elseif IJAWH_CurrentWrit.writType == CRAFTING_TYPE_ALCHEMY then
		return false
	elseif IJAWH_CurrentWrit.writType == CRAFTING_TYPE_ENCHANTING then
		for i=1, step do
			if not recipeData[i].func(recipeData[i]) then return end
		end
	elseif IJAWH_CurrentWrit.writType == CRAFTING_TYPE_PROVISIONING then
		for i=1, step do
			local numNeeded = GetRecipeIngredientRequiredQuantity(recipeData[i].recipeListIndex,recipeData[i].recipeIndex,z) * recipeData[i].numIterations
			local itemLink = GetRecipeIngredientItemLink(recipeData[i].recipeListIndex,recipeData[i].recipeIndex,z)
			local itemData = IJAWH:getItemDataFromLink(itemLink)
			local label, stackLabel, hasEnough = IJAWH:GetIngredientLabel(itemData,numNeeded)
			if not hasEnough then
				return true
			end
		end
	else
		local totalMaterial, totalItems, styleIndex = 0, 0, 0
		recipeData[step].canCraft = false
		for i=1, step do
			-- build material quantity that will be used by all items to be crafted
			totalMaterial = totalMaterial + recipeData[i].materialQuantity * recipeData[i].numIterations
			totalItems = totalItems + recipeData[i].numIterations
		end
		if totalMaterial > GetCurrentSmithingMaterialItemCount(recipeData[step].patternIndex, recipeData[step].materialIndex) then
			return true
		end
		styleIndex = IJAWH:UpdateSmithingStyleIndex(recipeData[step].numIterations, recipeData[step].patternIndex, totalItems)
		recipeData[step].styleIndex = styleIndex
		if styleIndex == 0 then return true end
		recipeData[step].canCraft = true
	end
end

-------------------------------------
-- Craft panel
-------------------------------------
local function updateWritText(qName)
	local styleListIndex = 1
	IJAWH:SetSmithingStyleList()	-- reset smithing style list
	
	local qIndex = getQuestIndex(qName)
	local writText = {}
	local step = 0
	for lineId = 1, GetJournalQuestNumConditions(qIndex,1) do
		local ingredLists = nil
		local condition,current,maximum,_,complete = GetJournalQuestConditionInfo(qIndex,1,lineId)
		convertedCondition = IJAWH:ConvertedCondition(condition)

		if condition ~= '' then
			local itemLink, conditionString
			local colour
			if IJAWH:Contains(condition, IJAWH:AcquireConditions()) then
				if current == maximum then
					colour = "00FF00"
				else
					colour = "CCCCCC"
				end
			elseif IJAWH:Contains(condition, IJAWH:CraftingConditions()) then
				if current == maximum then
					colour = "00FF00"
				else
					colour = "CCCCCC"
					step = step + 1
					if not IJAWH_CurrentWrit.recipeData[step] then break end
					itemLink = IJAWH_CurrentWrit.recipeData[step].itemLink:gsub("%|H1", "|H0")
					ingredLists, yPos = getIngredientData(step)
				end
			else
				colour = "00FF00"
			end
			
			local canCraft = true
			if itemLink then
				if notEnoughCraftingMaterial(step, styleListIndex) then
					conditionString = zo_strformat("|c<<1>><<2>>|r","E93C3C",GetString(SI_TRADESKILLRESULT141))
--					conditionString = zo_strformat(convertedCondition,"E93C3C",itemLink)
					canCraft = false
				else
					conditionString = zo_strformat(convertedCondition,colour,itemLink)
				end
			else
				conditionString = zo_strformat("|c<<1>><<2>>|r",colour,condition)
			end
			
			if ingredLists ~= nil then
				writText[#writText+1] = {condition = conditionString, ingredients = ingredLists, yPos = yPos, canCraft = canCraft}
			else
				writText[#writText+1] = {condition = conditionString}
			end
		end
	end	
	if IJAWH_CurrentWrit.writType ~= CRAFTING_TYPE_ALCHEMY then
		table.sort(IJAWH_CurrentWrit.recipeData, function(data1,data2)
			return ZO_TableOrderingFunction(data1, data2, "canCraft", WRIT_SORT_KEYS, ZO_SORT_ORDER_UP)
		end)
	end
	table.sort(writText, function(data1,data2) return ZO_TableOrderingFunction(data1, data2, "canCraft", WRIT_SORT_KEYS, ZO_SORT_ORDER_UP)  end)
	return writText
end
local function setConditionText(entry, text)
	entry.conditions:SetText(zo_strformat("<<1>>",text))
	entry.conditions:SetHorizontalAlignment(TEXT_ALIGN_LEFT)
	entry.conditions:SetAnchor(TOPLEFT, IsJustaWritHelper_CraftPanelDivider, TOPLEFT, 0, IJAWH_yPos)
	
	IsJustaWritHelper_CraftPanelConditions:SetText(zo_strformat("<<1>>",text))
	local origHeight = IsJustaWritHelper_CraftPanelConditions:GetTextHeight(IsJustaWritHelper_CraftPanelConditions:GetText())
	local newHeight = entry.conditions:GetTextHeight(entry.conditions:GetText())
	
	if newHeight > origHeight then
		IJAWH_yPos = IJAWH_yPos + 30
	end
end
local function setIngredientText(entry, text, yPos)
	IJAWH_yPos = IJAWH_yPos + 25
	entry.ingredients:SetText(zo_strformat("<<1>>",text))
	entry.ingredients:SetAnchor(TOP, IsJustaWritHelper_CraftPanelDivider, TOP, 0, IJAWH_yPos)
	IJAWH_yPos = IJAWH_yPos + yPos - 25
end
function IJAWH:showCraftPannel(condition)
	IJAWH_yPos = 20
	IJAWH_Igdnt_yPos = 0
	IJAWH_PANEL_HEIGHT = 70
	
	local writText, header = {}, ""
	if condition then	-- for Easy Alchemy
		local ingredients, yPos = getIngredientData(1)
		writText = {[1] = {condition = condition, ingredients = ingredients, yPos = yPos}}
		header = GetString(SI_IJAWH_EASYALCHEMY)
		IJAWH_PANEL_HEIGHT = IJAWH_PANEL_HEIGHT + 20
	else
		writText = updateWritText(IJAWH_CurrentWrit.qName)
		header = IJAWH_CurrentWrit.qName
	end
	
	if #writText > 0 then
		-- move Acquire line to top so the condition with ingredients will be at the bottom
		if string.find(writText[#writText].condition, GetString(IJAWH_ACQUIRE_STRING)) then table.sort(writText,  function(a,b) return a.condition < b.condition end) end
		for i=1, #writText do
			local conditionText = writText[i].condition or ""
			local ingredientText = writText[i].ingredients or nil
			
			local entry, key = IJAWH.writEntry:AcquireObject(i)
			entry:ClearAnchors()
			
			setConditionText(entry, conditionText)
			
			if ingredientText then setIngredientText(entry, ingredientText, writText[i].yPos) end
			IJAWH_yPos = IJAWH_yPos + 30
			entry:SetHidden(false)
		end
		IJAWH.craftPanel.icon:SetTexture(IJAWH.iconList[GetCraftingInteractionType()])
		IJAWH.craftPanel.header:SetText(zo_strformat("<<1>>",header))
		
		if not IJAWH.craftPanel.listControl:IsHidden() then
			IJAWH_LAST_PANEL_HEIGHT = IJAWH_PANEL_HEIGHT + IJAWH_yPos
			IJAWH.craftPanel.listControl:ClearAnchors()
			IJAWH.craftPanel.listControl:SetAnchor(TOP, IsJustaWritHelper_CraftPanelDivider, TOP, -5, IJAWH_yPos - 20)
			
			if IsInGamepadPreferredMode() then
				IJAWH_yPos = IJAWH_yPos + 80
			else
				IJAWH_yPos = IJAWH_yPos + 85
			end
		end
		
		if IJAWH_CurrentWrit.WithdrawText then
			IsJustaWritHelper_CraftPanelWithdrawDivider:ClearAnchors()
			IJAWH_yPos = IJAWH_yPos + 10
			IsJustaWritHelper_CraftPanelWithdrawDivider:SetAnchor(TOP, IsJustaWritHelper_CraftPanelDivider, TOP, 0, IJAWH_yPos)
			IsJustaWritHelper_CraftPanelWithdrawDivider:SetHidden(false)
			IJAWH_yPos = IJAWH_yPos + 15
			IJAWH.craftPanel.bankNotice:ClearAnchors()
			IJAWH.craftPanel.bankNotice:SetAnchor(TOP, IsJustaWritHelper_CraftPanelDivider, TOP, 0, IJAWH_yPos)
			
			IJAWH_yPos = IJAWH_yPos + 25
			local BankNoticeHeight = 25
			local WithdrawText = zo_strformat(SI_IJAWH_WITHDRAW_FROM_BANK, "E6E93C")
			for i=1, #IJAWH_CurrentWrit.WithdrawText do
				IJAWH_yPos = IJAWH_yPos + 30
				BankNoticeHeight = BankNoticeHeight + 30
				WithdrawText = WithdrawText .. "\n" .. IJAWH_CurrentWrit.WithdrawText[i]
			end
			IJAWH.craftPanel.bankNotice:SetHeight(BankNoticeHeight)
			IJAWH.craftPanel.bankNotice:SetText(WithdrawText)
			IJAWH.craftPanel.bankNotice:SetHidden(false)
		else
			IJAWH.craftPanel.bankNotice:SetHidden(true)
		end
		
		IJAWH_yPos = IJAWH_yPos + 10
		IJAWH_PANEL_HEIGHT = IJAWH_PANEL_HEIGHT + IJAWH_yPos
		IJAWH.craftTLW:SetHeight(IJAWH_PANEL_HEIGHT)
		
	elseif #writText > 0 and not canCraft() then
		table.remove(IJAWH.writData, IJAWH_WD_INDEX)
		IJAWH:refreshWritData()
	else
		IJAWH.craftTLW:SetHidden(true)
	end
end

local function cleanUp()
	EVENT_MANAGER:UnregisterForUpdate("IJAWH_setResultTooltip")
	IJAWH.craftPanel.bankNotice:SetText("")
	IJAWH:EnableReagentPanel(false)
	IsJustaWritHelper_CraftPanelWithdrawDivider:SetHidden(true)
	IJAWH_SMITHING_oldMode = 0
	EVENT_MANAGER:UnregisterForUpdate("IJAWH_setResultTooltip", 100, setResultTooltip)

	IJAWH.writEntry:ReleaseAllObjects()
end
local function hideWritPannel()
	if IJAWH.savedVariables.easyAlchemy then IsJustaEasyAlchemy.AlchemyTLW:SetHidden(true) end
	IJAWH.craftTLW:SetHidden(true)
end

-------------------------------------
--
-------------------------------------	
local function OnCraftStation(eventCode, craftingType, sameStation)
	if eventCode ~= 0 then -- 0 is an invalid code
		if IsSmithingCraftingType(craftingType) then
			getWritsFromJournal()
		end
		
		if #IJAWH.writData > 0 then
			ApplyTemplateToControl(IJAWH.craftTLW, ZO_GetPlatformTemplate("IsJustaWritHelper_CraftPanel"))
			IJAWH_CurrentWrit = getWritForStation()
			if IJAWH_CurrentWrit then 
				if IJAWH_CurrentWrit.recipeData and #IJAWH_CurrentWrit.recipeData > 0 then

					IJAWH:EnableReagentPanel(false)
					IJAWH:SetGamepadAnchors()
					setWritIndexFromQuestName(IJAWH_CurrentWrit.qName)
					IJAWH:setStationForWrit()

-- remove >
					if  IsInGamepadPreferredMode() then
						IJAWH.craftTLW:SetHidden(true)
					else
						IJAWH.craftTLW:SetHidden(true)
					end
-- <
					IJAWH:showCraftPannel()
					return
				end
			end
		end
	end
	
	if GetCraftingInteractionType() == CRAFTING_TYPE_ALCHEMY and IJAWH.savedVariables.easyAlchemy then
	-- if is alchemy but no alchemy writ then do easy alchemy
		if not isWritAdded(GetString(SI_IJAWH_EASYALCHEMY)) then addWrit(CRAFTING_TYPE_ALCHEMY, GetString(SI_IJAWH_EASYALCHEMY)) end
		IJAWH_CurrentWrit = {writType = CRAFTING_TYPE_ALCHEMY, qName = GetString(SI_IJAWH_EASYALCHEMY), recipeData = {}}
		setWritIndexFromQuestName(GetString(SI_IJAWH_EASYALCHEMY))
		IsJustaEasyAlchemy.isEasyAlchemy = true
		ApplyTemplateToControl(IJAWH.craftTLW, ZO_GetPlatformTemplate("IsJustaWritHelper_CraftPanel"))
		if IsInGamepadPreferredMode() then IJAWH:SetGamepadAnchors(CRAFTING_TYPE_ALCHEMY) end
	end
end

local function OnCloseCraftStation(eventCode)
	if eventCode ~= 0 then
		if IJAWH.craftKeybindButtonDescriptor then restoreCraftKeybind() end
		cleanUp()
--		IJAWH.activeEvents = {}
		IJAWH.CraftingData = {}
		IJAWH_CurrentWrit = {}
		hideWritPannel()
		IJAWH:RemoveKeybinds()
		IJAWH.craftPanel.header:SetText(GetString(SI_IJAWH_EASYALCHEMY))
		IsJustaEasyAlchemy:OnCloseAlchemyStation()
		
		if IsInGamepadPreferredMode() then -- restore gamepad recipe result and ingredient boxes positions
			ZO_GamepadAlchemyTopLevelSlotContainer:ClearAnchors()
			ZO_GamepadAlchemyTopLevelSlotContainer:SetAnchor(BOTTOM, GuiRoot, BOTTOMLEFT, ZO_GAMEPAD_PANEL_FLOATING_CENTER_QUADRANT_1_SHOWN, ZO_GAMEPAD_CRAFTING_UTILS_FLOATING_BOTTOM_OFFSET)
			ZO_GamepadProvisionerTopLevelIngredientsBar:ClearAnchors()
			ZO_GamepadProvisionerTopLevelIngredientsBar:SetAnchor(BOTTOM, GuiRoot, BOTTOMLEFT, ZO_GAMEPAD_PANEL_FLOATING_CENTER_QUADRANT_1_SHOWN, ZO_GAMEPAD_CRAFTING_UTILS_FLOATING_BOTTOM_OFFSET)
			ZO_GamepadEnchantingTopLevelRuneSlotContainer:ClearAnchors()
			ZO_GamepadEnchantingTopLevelRuneSlotContainer:SetAnchor(BOTTOM, GuiRoot, BOTTOMLEFT, ZO_GAMEPAD_PANEL_FLOATING_CENTER_QUADRANT_1_SHOWN, ZO_GAMEPAD_CRAFTING_UTILS_FLOATING_BOTTOM_OFFSET)
		end	
	end
end

-------------------------------------
-- on item crafted
-------------------------------------
local function isInCraftingMode()
	local scene = SCENE_MANAGER:GetCurrentScene():GetName()
	local craftingInteractionType = GetCraftingInteractionType()
	if IsSmithingCraftingType(craftingInteractionType) then
		if IsInGamepadPreferredMode() then
			if scene == "gamepad_smithing_creation" then return true end
		else
			if SMITHING.mode == 2 then return true end
		end
	elseif craftingInteractionType == CRAFTING_TYPE_ENCHANTING then
		if IsInGamepadPreferredMode() then
			if scene == "gamepad_enchanting_creation" then return true end
		else
			if ENCHANTING.mode == 2 then return true end
		end
	else
		return true
	end
end

local function ifOtherWritForStation()
	local station = GetCraftingInteractionType()
	if IJAWH.writData then
		for i=1, #IJAWH.writData do
			if IJAWH.writData[i].writType == station and not IJAWH.writData[i].completed then
				return true
			end
		end
	end
	return false
end

local function removeWithdrawItems()
	local craftingType = GetCraftingInteractionType()
	if not IsJustaEasyAlchemy.isEasyAlchemy then
--		if not isInCraftingMode() then return end	-- cancel if not in crafting mode (decon, refine, improvement, furniture)
		if IJAWH_WITHDRAW_ITEMS > 0 then
			local itemLinkName = GetItemLinkName(getCraftedItemLink())
			if not IsSmithingCraftingType(craftingType) then
				if IJAWH.withdrawItems[itemLinkName] then 
					IJAWH.withdrawItems[itemLinkName] = nil
					IJAWH_WITHDRAW_ITEMS = IJAWH_WITHDRAW_ITEMS - 1
				end
			end
			if IJAWH_WITHDRAW_ITEMS == 0 then
				EVENT_MANAGER:UnregisterForEvent("IJAWH_Open_Bank", EVENT_OPEN_BANK)
				IJAWH.activeEvents.OpenBank = false
			end
		end
	else
	end
end

onCraftItemUpdate = function(eventCode)
	removeWithdrawItems()
	zo_callLater(function()
		CALLBACK_MANAGER:UnregisterCallback("CraftingAnimationsStopped", onCraftItemUpdate)
		if not IJAWH_CurrentWrit.recipeData then return end
		IJAWH_CurrentWrit.recipeData[#IJAWH_CurrentWrit.recipeData] = nil	-- remove last recipeData from list
		KEYBIND_STRIP:UpdateKeybindButton(IJAWH.craftKeybindButtonDescriptor)
		
		IJAWH.writEntry:ReleaseAllObjects()
		CALLBACK_MANAGER:FireCallbacks("IJAWH_Update_Writs_Panel")

		if #IJAWH_CurrentWrit.recipeData > 0 and canCraft() then
			if IJAWH.craftKeybindButtonDescriptor then KEYBIND_STRIP:UpdateKeybindButton(IJAWH.craftKeybindButtonDescriptor) end
			IJAWH:showCraftPannel()
			craftWrit()
		elseif #IJAWH_CurrentWrit.recipeData > 0 and not canCraft() then
			IJAWH:showCraftPannel()
			restoreCraftKeybind()
		else
			cleanUp()
			IJAWH.writData[IJAWH_WD_INDEX].completed = true
			restoreCraftKeybind()
			if ifOtherWritForStation() then
				OnCraftStation(1)
			else
				if IJAWH.savedVariables.autoExit then
					SCENE_MANAGER:ShowBaseScene()
				else
					IJAWH:showCraftPannel()
				end
			end
		end
	end, 200)
end

-------------------------------------
--
-------------------------------------
function IJAWH:SetGamepadAnchors()
	ZO_GamepadAlchemyTopLevelSlotContainer:ClearAnchors()
	ZO_GamepadAlchemyTopLevelSlotContainer:SetAnchor(BOTTOM, GuiRoot, BOTTOMLEFT, ZO_GAMEPAD_PANEL_FLOATING_CENTER_QUADRANT_1_2_SHOWN, ZO_GAMEPAD_CRAFTING_UTILS_FLOATING_BOTTOM_OFFSET)
	ZO_GamepadProvisionerTopLevelIngredientsBar:ClearAnchors()
	ZO_GamepadProvisionerTopLevelIngredientsBar:SetAnchor(BOTTOM, GuiRoot, BOTTOMLEFT, ZO_GAMEPAD_PANEL_FLOATING_CENTER_QUADRANT_1_2_SHOWN, ZO_GAMEPAD_CRAFTING_UTILS_FLOATING_BOTTOM_OFFSET)
	ZO_GamepadEnchantingTopLevelRuneSlotContainer:ClearAnchors()
	ZO_GamepadEnchantingTopLevelRuneSlotContainer:SetAnchor(BOTTOM, GuiRoot, BOTTOMLEFT, ZO_GAMEPAD_PANEL_FLOATING_CENTER_QUADRANT_1_2_SHOWN, ZO_GAMEPAD_CRAFTING_UTILS_FLOATING_BOTTOM_OFFSET)
end
local function changeMode()
	if IJAWH_WRITLIST and #IJAWH_WRITLIST > 0 then
		CALLBACK_MANAGER:FireCallbacks("IJAWH_Update_Writs_Panel")
	end
end

-------------------------------------
--
-------------------------------------
local function getNewQuests()
	getWritsFromJournal()
	IJAWH.writsPanel.writList:ReleaseAllObjects()
	writsPanelControl()
end
function IJAWH:refreshWritData()

	local qNameList, remainingWrits, remainingWithdraws = {}, {}, {}
	
	for qIndex=1, MAX_JOURNAL_QUESTS do
		if IsValidQuestIndex(qIndex) then
			local qName,_,qDesc,_,_,qCompleted  = GetJournalQuestInfo(qIndex)
			if GetJournalQuestType(qIndex) == QUEST_TYPE_CRAFTING and isWritAdded(qName) then
				qNameList[#qNameList +1] = qName
			end
		end
	end
	
	if #self.writData > 0 then
		for i=1, #self.writData do
			if self:Contains(self.writData[i].qName,qNameList) then
				remainingWrits[#remainingWrits +1] = self.writData[i]
			end
		end
		self.writData = remainingWrits
	end
	
	if self.withdrawItems then
		for k,v in pairs(self.withdrawItems) do
			if self:Contains(v.qName,qNameList) then
				remainingWithdraws[#remainingWithdraws + 1] = v
			end
		end
		if #remainingWithdraws > 0 then
			self.withdrawItems = remainingWithdraws
		else
			self.withdrawItems =  {}
			EVENT_MANAGER:UnregisterForEvent("IJWH_Open_Bank", EVENT_OPEN_BANK)
		end
	end
	getNewQuests()
end

-------------------------------------
-- Daily-Writ new and auto-complete
-------------------------------------
local autoAccept
local ignoreStolenItems = true
local WRIT_TurnInUpdate = false
local lastInteractionTme = 0
local step = 0
local getNextContainer

local function isWritCoffer(name)
	local writCoffers = {
		IJAWH_WRITCRATE_CLOTHIER, 
		IJAWH_WRITCRATE_WOODWORKER, 
		IJAWH_WRITCRATE_BLACKSMITH, 
		IJAWH_WRITCRATE_JEWELRY, 
		IJAWH_WRITCRATE_ENCHANTER,
		IJAWH_WRITCRATE_PROVISIONER, 
		IJAWH_WRITCRATE_ALCHEMIST, 
		IJAWH_WRITSHIPMENT
	}
	name = string.gsub(name , "[%']", "")
	for k,containerName in pairs(writCoffers) do
		if name ~= '' then
			if string.match(name, containerName) then 
				return true
			end
		end
	end
	return false
end

local function onLootUpdated(...)
	EVENT_MANAGER:UnregisterForEvent("IJAWH_WRIT_OnLootUpdated", EVENT_LOOT_UPDATED)
	
	zo_callLater(getNextContainer, 1000)
	LOOT_SHARED.LootAllItems()
	SCENE_MANAGER:ShowBaseScene()
		
--	GetNumLootItems()
end

local function GetSetItemDataFilterComparator()
	return function(itemData)
		local itemType, specializedItemType = GetItemType(itemData.bagId, itemData.slotIndex)
		return specializedItemType == 850
	end
end

local function getFirstContainerSlotId()
	if not CheckInventorySpaceSilently(1) then
		return false
	end
	
	local comparator = GetSetItemDataFilterComparator()
	local bags = {BAG_BACKPACK, BAG_BANK, BAG_SUBSCRIBER_BANK}
	local filteredDataTable = SHARED_INVENTORY:GenerateFullSlotData(comparator, BAG_BACKPACK)
	for _, itemData in pairs(filteredDataTable) do
		return itemData.slotIndex
	end
	return false
end
getNextContainer = function(eventCode)
	EVENT_MANAGER:UnregisterForEvent("IJAWH_OnLootClosed", EVENT_LOOT_CLOSED)
	step = 0
	local slotId = getFirstContainerSlotId()
	if slotId then
		EVENT_MANAGER:RegisterForEvent("IJAWH_WRIT_OnLootUpdated", EVENT_LOOT_UPDATED, onLootUpdated)
		
		zo_callLater(function()
			CallSecureProtected("UseItem", BAG_BACKPACK, slotId)
		end, 50)
		
	else
--		if SmarterAutoLoot then SmarterAutoLootToggleKey() end
		EVENT_MANAGER:UnregisterForEvent("IJAWH_OnInventoryUpdate", EVENT_INVENTORY_SINGLE_SLOT_UPDATE)
	end
end

local function startOpeningContainers()
	local elapsedTime = getTimeElapsed(lastInteractionTme)
	local delay = IJAWH.savedVariables.autoOpenDelay
	if elapsedTime >= delay then
--		if SmarterAutoLoot then SmarterAutoLootToggleKey() end
		EVENT_MANAGER:UnregisterForUpdate("IJAWH_WRIT_TurnInUpdate")
		WRIT_TurnInUpdate = false
		getNextContainer()
	end
end

local function writTurnIn()
	if GetInteractionType() == INTERACTION_QUEST then
		EVENT_MANAGER:UnregisterForEvent("IJAWH_QUEST_COMPLETE_DIALOG", EVENT_QUEST_COMPLETE_DIALOG, writTurnIn)
		lastInteractionTme = GetTimeStamp()
		
		if IJAWH.savedVariables.autoOpen and not WRIT_TurnInUpdate and getFirstContainerSlotId() then
			WRIT_TurnInUpdate = true
			EVENT_MANAGER:RegisterForUpdate("IJAWH_WRIT_TurnInUpdate", 100, startOpeningContainers)
		end		
		
		CompleteQuest()
		IJAWH:refreshWritData()
	end
end

local function onChatterEnd()
	EVENT_MANAGER:UnregisterForEvent("IJAWH_WRIT_CHATTER_END", EVENT_CHATTER_END, onChatterEnd)
	if IJAWH.hasNewWrit then
		getNewQuests()
		IJAWH.hasNewWrit = false
	end
end

local function acceptQuest(eventCode)
    EVENT_MANAGER:UnregisterForEvent("IJAWH_QUEST_ACCEPT", EVENT_QUEST_OFFERED)
    AcceptOfferedQuest()
	autoAccept()
end

autoAccept = function()
	local optionText, optiontype = GetChatterOption(1)
	
	if string.find(optionText, GetString(SI_IJAWH_WRIT)) and GetNumJournalQuests() < MAX_JOURNAL_QUESTS then
		EVENT_MANAGER:RegisterForEvent("IJAWH_QUEST_ACCEPT", EVENT_QUEST_OFFERED, acceptQuest)
		SelectChatterOption(1)
	else
		return
	end
end

local isFromBoard = false
local function onChatterBegin()
	IsJustaWritHelper_WritsPanel:SetHidden(true)
	if GetInteractionType() == INTERACTION_CONVERSATION then
		for i=1, GetChatterOptionCount() do
			local optionText, optiontype = GetChatterOption(i)
			if optiontype == CHATTER_START_NEW_QUEST_BESTOWAL then
				isFromBoard = true
				EVENT_MANAGER:RegisterForEvent("IJAWH_WRIT_CHATTER_END", EVENT_CHATTER_END, onChatterEnd)
				if IJAWH.savedVariables.autoAccept then
					if GetNumJournalQuests() < MAX_JOURNAL_QUESTS then
						autoAccept()
					end
				end
				return
			elseif optiontype == CHATTER_START_ADVANCE_COMPLETABLE_QUEST_CONDITIONS or optiontype == CHATTER_START_COMPLETE_QUEST then
				if string.find(optionText, GetString(SI_IJAWH_GOODS)) or string.find(optionText, GetString(SI_IJAWH_SIGN)) or string.find(optionText, GetString(SI_IJAWH_JOB)) then
					EVENT_MANAGER:RegisterForEvent("IJAWH_QUEST_COMPLETE_DIALOG", EVENT_QUEST_COMPLETE_DIALOG, writTurnIn)
					SelectChatterOption(i)
				end
			end
		end
	end
end
local function onWritAccepted(...)
	local  _, _, writName = ...
	if isFromBoard then
		if 	string.find(writName, GetString(SI_IJAWH_WRIT)) or string.find(writName, GetString(SI_IJAWH_CERT)) then
			IJAWH.hasNewWrit = true
			isFromBoard = false
		end

	-- added to show master writs in the writ panel when the writ is used from inventory
	-- only non-smithing master writs can be made with this addon but all will show in the Writ Panel
	elseif string.find(writName, GetString(SI_IJAWH_MASTERFUL)) or string.find(writName, GetString(SI_IJAWH_WRIT)) then
		getNewQuests()
	end
end

-------------------------------------
-- Startup functions
-----------------------------------
local function onCommandEntered(args)
    if args == 'reset' or args == 'r' then
		IJAWH_WRITLIST = {}
		IJAWH.writData = {}
        getNewQuests()
		ZO_Alert(UI_ALERT_CATEGORY_ERROR, SOUNDS.NEGATIVE_CLICK, GetString(SI_OPTIONS_RESET))
    end
	    if args == 'loot' or args == 'l' then
        startOpeningContainers()
    end
end

local function OnPlayerActivated()
--	lastInteractionTme = GetTimeStamp()
--	EVENT_MANAGER:RegisterForUpdate("IJAWH_WRIT_TurnInUpdate", 1000, startOpeningContainers)

	EVENT_MANAGER:UnregisterForEvent("IJAWH_PLAYER_ACTIVATED", EVENT_PLAYER_ACTIVATED)
	
	if not TamrielTradeCentre then
		d(zo_strformat(IJAWH.displayName),GetString(SI_IJAWH_TTC_INSTALL))
	elseif IJAWH.savedVariables.priorityBy == GetString(SI_IJAWH_PRIORITY_BY_TTC) then
		local totalSecPerDay = 24 * 60 * 60
		local elapsedTime = getTimeElapsed(TamrielTradeCentrePrice.PriceTable.TimeStamp)
		local elapsedDays = elapsedTime/totalSecPerDay
		if (elapsedDays > 3) then
			d(zo_strformat(IJAWH.displayName),GetString(SI_IJAWH_TTC_UPDATE))
		end
	end
	zo_callLater(getNewQuests, 500)
	
	--	event that control the writs panel
	EVENT_MANAGER:RegisterForEvent("IJAWH_PLAYER_ACTIVATED", EVENT_PLAYER_ACTIVATED, writsPanelControl)
--	EVENT_MANAGER:RegisterForEvent("IJAWH_CHATTER_END", EVENT_CHATTER_END, writsPanelControl)
	EVENT_MANAGER:RegisterForEvent("IJAWH_PLAYER_COMBAT_STATE", EVENT_PLAYER_COMBAT_STATE, writsPanelControl)
	EVENT_MANAGER:RegisterForEvent("IJAWH_PLAYER_DEAD", EVENT_PLAYER_DEAD, writsPanelControl)
	EVENT_MANAGER:RegisterForEvent("IJAWH_PLAYER_ALIVE", EVENT_PLAYER_ALIVE, writsPanelControl)
	EVENT_MANAGER:RegisterForEvent("IJAWH_GROUP_MEMBER_JOINED", EVENT_GROUP_MEMBER_JOINED, writsPanelControl)
	EVENT_MANAGER:RegisterForEvent("IJAWH__GROUP_MEMBER_LEFT", EVENT_GROUP_MEMBER_LEFT, writsPanelControl)
	EVENT_MANAGER:RegisterForEvent("IJAWH_MOUNTED_STATE_CHANGED", EVENT_MOUNTED_STATE_CHANGED, writsPanelControl)
	
	d( IJAWH.displayName .. "|cffffff non-beta will soon be at ESOUI.com|r")
--	d( IJAWH.displayName .. "|cffffff this is the testing version. Get the non-beta from ESOUI.com|r")
end
function IJAWH:Setup()
	local AccountWideSavedVars = ZO_SavedVars:NewAccountWide("IJAWH_SavedVars", IJAWH.svVersion, nil, IJAWH.DefaultSettings)
	local characterSavedVars = ZO_SavedVars:New("IJAWH_SavedVars", IJAWH.svVersion, nil, nil)

	if AccountWideSavedVars.character then
		IJAWH.savedVariables = characterSavedVars
	else
		IJAWH.savedVariables = AccountWideSavedVars
	end
	if not self.savedVariables.tutorials then IJAWH.savedVariables.tutorials = {} end
	
	EVENT_MANAGER:RegisterForEvent("IJAWH_CRAFTING_STATION_INTERACT", EVENT_CRAFTING_STATION_INTERACT, OnCraftStation)
	EVENT_MANAGER:RegisterForEvent("IJAWH_END_CRAFTING_STATION_INTERACT", EVENT_END_CRAFTING_STATION_INTERACT, OnCloseCraftStation)
	EVENT_MANAGER:RegisterForEvent("IJAWH_QUEST_ADDED", EVENT_QUEST_ADDED, onWritAccepted)
	EVENT_MANAGER:RegisterForEvent("IJAWH_CHATTER_BEGIN", EVENT_CHATTER_BEGIN, onChatterBegin)
	EVENT_MANAGER:RegisterForEvent("IJAWH_QUEST_REMOVED", EVENT_QUEST_REMOVED, function() IJAWH:refreshWritData() end)

	self:CreateMenu()
	self:CreateWritPanel()
	
--	CRAFTPANNEL_FRAGMET = ZO_FadeSceneFragment.New(self:CreateCraftPanel())
	
	self:BuildDialogInfo()
	if self.savedVariables.easyAlchemy then IsJustaEasyAlchemy:Initialize() end
	self:InitializeKeybindStripDescriptors()
	
	setUpCallbacks()
	
	SLASH_COMMANDS["/ijawh"] = onCommandEntered
end
function IJAWH.OnLoad(eventCode, addOnName)
	if addOnName ~= IJAWH.name then
        return
    end
	
	EVENT_MANAGER:UnregisterForEvent("IJAWH_ADD_ON_LOADED", EVENT_ADD_ON_LOADED)
	EVENT_MANAGER:RegisterForEvent("IJAWH_PLAYER_ACTIVATED", EVENT_PLAYER_ACTIVATED, OnPlayerActivated)
	IJAWH:Setup()
end

EVENT_MANAGER:RegisterForEvent("IJAWH_ADD_ON_LOADED", EVENT_ADD_ON_LOADED, IJAWH.OnLoad)
EVENT_MANAGER:RegisterForEvent("IJAWH_ON_MODE_CHANGED", EVENT_GAMEPAD_PREFERRED_MODE_CHANGED, function(code, inGamepad) zo_callLater(changeMode,500) end)
